/*
 Programa Ŀ
   Aplication: class TGrid                                                
         File: GRID.PRG                                                   
       Author: Francisco Garca Fern ndez                                 
     Internet: http://www.arrakis.es/~canal_five/                         
     Internet: http://come.to/canalfive                                   
       E-Mail: canal_five@arrakis.es                                      
         Date: 20-dic-1999                                                
         Time: 22:30:00                                                   
      Version: 2.0V                                                       
    Copyright: 1997 by Francisco Garca Fern ndez                         

*/

#include "fivewin.ch"
#include "C5grid.ch"


#define GW_HWNDFIRST          0
#define GW_HWNDLAST           1
#define GW_HWNDNEXT           2
#define GWL_STYLE           -16

#define HWND_BROADCAST    65535  // 0xFFFF

#define CS_DBLCLKS            8
#define COLOR_ACTIVECAPTION   2
#define COLOR_CAPTIONTEXT     9
#define COLOR_BTNFACE        15

#define WM_SETFONT           48  // 0x30

#define DATOSCELL 9

#define GPANE       1
#define GTEXT       2
#define GFONT       3
#define GALIGN      4
#define GBLOCKPANE  5
#define GPENPANE    6
#define GPENTEXT    7
#define GPENBPANE   8
#define GPENBTEXT   9

#define GUP    1
#define GDOWN  2
#define GLEFT  3
#define GRIGHT 4
#define RESIZE 5

#define DT_EXPANDTABS       64  //  0x0040

#define COLOR_BTNSHADOW       16
#define COLOR_BTNHIGHLIGHT    20

#define ALINEACION {32,33,34,36,37,38,40,41,42,0,16,17 }

static nMRow, nMCol
static lDragging := .f., nDragCol := 0

static nRow1, nCol1, nRow2, nCol2
static nOldClrInAB  := -1
static nOldClrActB  := -1
static nOldLeftCel


extern DBSKIP, GetTextWid, cDrives


CLASS TGrid FROM TControl


      DATA aoColumns                  // array de objetos columnas

      // 27/07/97
      *DATA aCells                   // array definition of cells
                               // supressed for memory problems
                               // change for aColCells in each column object

      // 27/07/97
      DATA aFonts                  // arrays for the management of the fonts

      DATA aBrushes, aColors       // arrays for the management of the
                                   // background color
      // 27-07-97
      DATA aTxtColors              // arrays for the management of the
                                   // foreground color

      DATA aPens                   // arrays for the managemente of the colors
                                   // for paint the side of the focus

      DATA aTabla                  // keep a reference to the array
                                   // in case the grid be to the one array

      DATA nHRow                   // height to pixels of the row

      DATA cAlias                  // alias

      DATA nRowPos                 // absolute row
      DATA nColPos                 // the first column into the screen

      DATA nRows2Scr               // reals rows into screen

      DATA nColScr                 // nColScr is the relative column where
                                   // is the cell active, respect of the
                                   // left of the grid.

      DATA nLinesHdr               // headers lines
      DATA nPixHHdr                // Height the header above in pixels
      DATA nCols                   // number of defined columns
      DATA nRightCol               // the last column that I had painted integer
                                   // for the right
      DATA nRightRC                // place where stay the right of nRightCol

      DATA lHitTop                    // Is the top                 ?
      DATA lHitBottom                 // Is the bottom              ?
      DATA lCaptured                  // capturated mouse           ?
      DATA lNeedScrl                  // need scroll                ?
      DATA lLastPage                  // last page                  ?
      DATA lVScroll, lHScroll         // have scroll bars           ?
      DATA lEditLine                  // edicion en linea           ?
      DATA lVGrid, lHGrid             // grid vertical y horizontal ?
      DATA lHeader                    // Tiene cabecera             ?
      DATA lBorder                    // tiene borde                ?
      DATA lVisible                   // es visible ? (creo que no se utiliza)
      DATA lGrid
      DATA lClrRows                   // estan coloradas las filas
                                      // independientemente ?

      DATA lFoots                     // implementa pies para las columnas

      DATA lBar                       // en lugar de cell se pinta barra
      DATA lNoHilite                  // iluminamos la seleccin ?

      DATA lMChange

      DATA lChangeW                   // estoy cambiando el tamao de una columna ?
      DATA lFastDef                   // definicion r pida del grid para un dbf
      DATA lNoResizeCol               // se redimensionan las columnas ?
      DATA lNoDragCol                 // no permite mover las columnas

      DATA lCompatible                // compatibilizar la forma de comunicar
                                      // los arrays de  TWBrowse.
                                      // un array de nCol elementos por cada
                                      // linea del grid

      DATA lIsCreate
      DATA lMakeFont                  // if the font is create into the TGrid
                                      // class

      DATA lShow1Array                // estoy mostrando un solo array
                                      // no es array de array

      //27-07-97
      DATA lMdiChild                 // for redim ::nLines to 60 lines
                                     // maximum of lines
      // 28-07-98 2.0Q
      DATA lAdd                      // Para aadir registros en la edicin
                                     // en lnea si estamos en el ltimo
                                     // registro.
      //31-07-98
      DATA lFilter

      DATA nClrTFoc                   // color del texto de la celda activa
      DATA nClrPFoc                   // color del fondo de la celda activa
      DATA nBClrFoc                   // numero de brocha de la celda activa

      DATA nTopCell                   // coordenadas de la celda a dibujar
      DATA nLeftCell
      DATA nBottomCell
      DATA nRightCell

      DATA nOldCol                    // antigua coluna seleccionada
      DATA nColumn                    // columna que acabo de pinchar

      DATA nWidthCli, nHeightCli      // ancho y alto del control

      DATA oPenGrid, nClrGrid         // brocha del cell con el foco
                                      // pen    del cell con el foco
                                      // color  del grid

      DATA bGoTop, bGoBottom
      DATA bSkip
      DATA bLogicLen
      DATA bChange

      DATA bAction

      DATA nLen                       // numero de elementos del grid en
                                      // un momento dado

      DATA nAt                        // registro en el que me encuentro
                                      // fisicamente dentro del grid

      DATA oTimeOut, nTimeOut         // timeout para el get

      DATA cPath

      DATA lNoAutoSize

      DATA nClrInAb, nClrActB
      DATA hBordeIz, hBordeDer

      DATA cTxtFile, nLeftTxt

      DATA cField
      DATA uValue1
      DATA uValue2

      DATA nMaxFilter                 // Maximum number of records to count

      DATA oOut  READONLY
      DATA nTime READONLY AS NUMERIC INIT 0

      DATA cBuffer AS CHARACTER INIT ""  //  utilizado para la busqueda inc.

      DATA lTotalizar

      DATA lEditting

      DATA lExist

      // 2.0R
      DATA oGet, bGetValid, vKeyGet

      // 2.0S
      DATA bUserAdd

      *DATA lEdAnyKey AS LOGICAL INIT .F.

      // 2.0V
      DATA lUserMenu AS LOGICAL INIT .T.


      CLASSDATA lRegistered AS LOGICAL

      METHOD New( nTop, nLeft, nWidth, nHeight, oWnd,;
                  nHRow, lVGrid, lHGrid, nClrTFoc, nClrPFoc,;
                  lVScroll, lHScroll, nClrText, nClrPane,;
                  oFont, lBorder, nClrGrid, nLinesHdr, cAlias,;
                  lBar, lNoHilite, lFoots, lEditLine, ;
                  bAction, lFastDef, bChange, lNoAutoSize, bRClicked )  CONSTRUCTOR

      METHOD Redefine( oDlg, nId ;
                  nHRow, lVGrid, lHGrid, nClrTFoc, nClrPFoc,;
                  lVScroll, lHScroll, nClrText, nClrPane,;
                  oFont, lBorder, nClrGrid, nLinesHdr, cAlias,;
                  lBar, lNoHilite, lFoots, lEditLine, ;
                  bAction, lFastDef, bChange, bRClicked )  CONSTRUCTOR


      METHOD AddColumn( oColumn )

      METHOD nAtCol( nColPixel )

      METHOD AsignVal( oDlg, oGet, lArray, nOldFoot, nOldVal )

      METHOD Cuantas( nWidht )
      METHOD ChangePath( cItem )


      METHOD cToChar( cCtrlClass )

      METHOD DameBlock ( aArray )
      METHOD Default()

      METHOD DefControl( oCtrl ) INLINE AAdd( ::aControls, oCtrl ),;
                                                 oCtrl:hWnd = 0

      METHOD DelColumn( nColumn )

      METHOD Destroy()
      METHOD Direct( cPath, cUnidad )
      METHOD Display()

      METHOD DragBegin( nRow, nCol, nKeyFlags )


      METHOD FillStep ( nClrText, nClrPane, lRow, nIni, nStep, nIni2, nStep2,;
                       anLessRows, anLessCols )

      METHOD FillFont ( nRow, nCol, oFont )

      METHOD GetData( nCol )

      METHOD GetColSizes()

      METHOD GoUp  ( lFromPage )
      METHOD GoDown( lFromPage )
      METHOD GoLeft( lVisible )
      METHOD GoRight()
      METHOD GoTop()
      METHOD GoBottom()

      METHOD GotFocus()

      METHOD HScroll( nWParam, nLParam )

      * El mtodo Init se llama desde el activate de TDialog
      * con un Asend( ::aControls, "INIT", ::hWnd)

      METHOD Initiate( hDlg ) INLINE Super:Initiate( hDlg ), ::Default()
      METHOD Init( hDlg ) INLINE Super:Init( hDlg ), ::Default()

      METHOD KeyDown( nKey, nFlags )
      METHOD KeyChar( nKey, nFlags )

      METHOD LButtonDown( nRow, nCol, nKeyFlags )
      METHOD LButtonUp( nRow, nCol, nKeyFlags )

      METHOD LDblClick( nRow, nCol, nKeyFlags, lVk_Ret )

      METHOD LostFocus() INLINE Super:LostFocus(),  ;
                   If( ::nLen > 0 .and. ! Empty( ::cAlias ), ,)

      METHOD MouseMove( nRow, nCol, nKeyFlags )

      METHOD MoveCell( nSide )

      METHOD PageUp( nLines )
      METHOD PageDown( nLines )

      METHOD Paint ( nColumna, nColLeft, nCols )
      METHOD PaintCell( lErase )
      METHOD PaintDatos( nColumna, nColLeft, nCols, lCount )
      METHOD PaintHDr  ()
      METHOD PaintLine ( nLine, nColumna, nColLeft, lFocus, nCols )
      METHOD PaintFoots()

      METHOD RButtonDown( nRow, nCol, nKeyFlags )
      MESSAGE nRealCol() METHOD _nRealCol ()

      METHOD RegisColor( nColor )

      // added 29/07/97 for register the fonts
      METHOD RegisFont( oFont )
      METHOD RegisTxtC( nClrText )


      METHOD RefreshLine() INLINE ::PaintLine(),::PaintCell()

      //added 29/08/97 for edition out of grid
      METHOD RefreshFeet()

      METHOD Reset()

      METHOD nRowCount() INLINE ::nWRows() - If ( ::lHeader, ::nLinesHdr, 0 )

      MESSAGE nLines() METHOD _nLines()

      METHOD Seek( cData, lAprox )

      METHOD SetArray( aArray, lCompatible )


      METHOD ChangeArray( aArray )

      METHOD SetDbf( cAlias )
      METHOD SetTxt( cTxtFile )

      MESSAGE RecCount METHOD _RecCount( uSeekValue )

      METHOD SetFilter( cField, uVal1, uVal2 )

      //27-07-97
      METHOD SetValue( nCol, nRow, nElement, nValue )
      METHOD GetValue( nCol, nRow, nElement )


      METHOD SetHRow ( nHRow )
      METHOD Set2Order( nOrder )

      METHOD SwitchCol( nCol, nCol2, lRefresh )
      METHOD InsertCol( nCol, nCol2 )

      METHOD Skip( n )

      METHOD TotalCols()

      METHOD VertLine( nColPos, nColInit )
      METHOD nWRow( nRow )
      METHOD nWRows()
      METHOD VScroll( nWParam, nLParam )

      METHOD Ver( C, U)

      * metodos para terminar el bloqueo de registros en la edicin
      METHOD InitTimeOut( oDlg )

      METHOD EndTimeOut()

   METHOD GetDlgCode( nLastKey )

   METHOD MiError( oError )

   METHOD xDelete  ( )
   METHOD xReccount( )
   METHOD nCalcRow ( nOrder, nOldRec )
   METHOD Refresh  ( lErase )
   METHOD BtnLook  ( hDC, nTop, nLeft, nBottom, nRight )
   METHOD AdjCols  ( nIni, nWidth )

   // 28-07-98 2.0Q
   *METHOD GoNextLine( )

   // 2.0S  borrar filas en un array
   METHOD ADelRow( nRow )

   // 2.0T
   METHOD NewArray( aTabla )

   // 2.0U
   METHOD ASeek( uValue, nCol )


ENDCLASS

       ****************************************************************
         METHOD New( nTop, nLeft, nWidth, nHeight, oWnd,;
                     nHRow, lVGrid, lHGrid, nClrTFoc, nClrPFoc,;
                     lVScroll, lHScroll, nClrText, nClrPane,;
                     oFont, lBorder, nClrGrid, nLinesHdr, cAlias,;
                     lBar, lNoHilite, lFoots, lEditLine, ;
                     bAction, lFastDef, bChange, lNoAutoSize, bRClicked ) CLASS TGrid
       *****************************************************************

   DEFAULT lVGrid := .t., lHGrid := .t.,;
         nWidth := 200, nHeight := 200,;
         nClrTFoc := CLR_WHITE, nClrPFoc := CLR_BLUE,  nClrGrid := CLR_BLACK ,;
         lVScroll := .t., lHScroll := .t.,;
         nClrText := CLR_BLACK, nClrPane := CLR_WHITE,;
         lBorder := .t., nLinesHdr := 1, lBar := .f., cAlias := "ARRAY",;
         lNoHilite := .f., lFoots := .f., lEditLine := .f.,;
         lFastDef := .f., lNoAutoSize := .f.


   ::nTop       = nTop
   ::nLeft      = nLeft
   ::nBottom    = ::nTop + nHeight - 1
   ::nRight     = ::nLeft + nWidth - 1
   ::oWnd       = oWnd
   ::lBar       = lBar

   If ::oWnd:ClassName == "TMDICHILD"
      ::lMdiChild  := .T.
   else
      ::lMdiChild  := .F.
   endif


   ::bAction    = bAction
   ::bChange    = bChange
   ::bRClicked  = bRClicked

   If oFont == nil
      DEFINE FONT ::oFont NAME "Ms Sans Serif" SIZE 6, 12
      ::lMakeFont := .t.
   else
      ::oFont := oFont
      ::lMakeFont := .f.
   endif


   if nHRow == nil
      ::nHRow := abs(::oFont:nHeight)  + 8
   else
      ::nHRow      = nHRow
   endif

   ::aoColumns  = {}
   *::aCells     = nil
   ::aBrushes   = {}
   ::aColors    = {}
   ::aPens      = {}
   ::aControls  = {}

   ::cAlias      = upper(cAlias)

   ::nClrText := nClrText
   ::nClrPane := nClrPane

   //27-07-97
   ::aFonts     = {}
   ::aTxtColors = {}
   ::RegisFont( ::oFont )
   ::RegisTxtC( ::nClrText )

   // add  27/08/97
   ::lTotalizar  := .t.

   ::SetColor( nClrText, nClrPane )
   ::oBrush := TBrush():New(,nClrPane)

   ::RegisColor( nClrText )   // for colors of the pens
   ::RegisColor( nClrPane )

   ::nClrTFoc := nClrTFoc
   ::nClrPFoc := nClrPFoc
   ::nBClrFoc := ::RegisColor( ::nClrPFoc )

   ::lHitTop    = .t.
   ::lHitBottom = .f.
   ::lCaptured  = .f.
   ::lNeedScrl  = .f.
   ::lLastPage  = .f.
   ::lVScroll   = lVScroll
   ::lHScroll   = lHScroll
   ::lEditLine  = lEditLine
   ::lVGrid     = lVGrid
   ::lHGrid     = lHGrid
   ::lGrid      = if ( ::lVGrid .or. ::lHGrid, .t., .f. )
   ::lFocused   = .f.
   ::lMChange   = .t.
   ::lBorder    = lBorder
   ::lClrRows   = .f.
   ::lChangeW   = .f.
   ::lNoHilite  = lNoHilite
   ::lFoots     = lFoots
   ::lFastDef   = lFastDef
   ::lNoAutoSize = lNoAutoSize
   ::lNoResizeCol = .F.
   ::lNoDragCol   = .f.
   ::lShow1array  = .f.
   ::lAdd         = .f.

   ::lEditting    = .f.
   ::lUpdate   = .t.
   ::lFilter    = .f.

   ::nTimeOut   = 60
   ::nColPos    = 1
   ::nRowPos    = 1
   ::nColScr    = 1
   ::nCols      = 0
   ::nLinesHdr  = nLinesHdr
   ::nAt        = 1
   ::nLeftTxt   = 1

   ::lHeader    = ::nLinesHdr != 0
   ::lIsCreate  := .f.



   ::nId        = ::GetNewId()

   ::nStyle     = nOr( WS_CHILD, WS_VSCROLL, WS_HSCROLL, ;
                       if( ::lBorder, WS_BORDER,0),;
                       WS_VISIBLE, WS_TABSTOP, WS_CLIPSIBLINGS )

   ::nClrGrid := nClrGrid
   ::oPenGrid := TPen():New(,,::nClrGrid )

   ::Register( nOr( CS_VREDRAW, CS_HREDRAW, CS_DBLCLKS ) )


   * cuando estamos creandolo en una TWindow oWnd ya est  creada al llegar aqui
   if ! Empty( oWnd:hWnd )
      ::Create()
      ::lIsCreate  := .t.
      //27/08/97
      ::Default()
      ::lVisible = .t.
      oWnd:AddControl( Self )
   else
      * aqui todava no existe la caja de di logo
      * solo se aade el objeto al array aControls de la caja de di logo

      oWnd:DefControl( Self )
      ::lVisible = .f.

   endif

   if upper(::cAlias) # "ARRAY"

      ::bGoTop     = { || ( ::cAlias )->( DbGoTop() ) }
      ::bGoBottom  = { || ( ::cAlias )->( DbGoBottom() ) }
      ::bSkip      = { | n | ( ::cAlias )->( _DbSkipper( n ) ) }
      ::bLogicLen  = {|| (::cAlias)->( ::xReccount()) }
      ::nLen       = Eval( ::bLogicLen )

   endif


return self

********************************************************************
      METHOD Redefine( oDlg, nId, ;
                  nHRow, lVGrid, lHGrid, nClrTFoc, nClrPFoc,;
                  lVScroll, lHScroll, nClrText, nClrPane,;
                  oFont, lBorder, nClrGrid, nLinesHdr, cAlias,;
                  lBar, lNoHilite, lFoots, lEditLine, ;
                  bAction, lFastDef, bChange, bRClicked ) CLASS TGrid
********************************************************************

   DEFAULT lVGrid := .t., lHGrid := .t.,;
         nClrTFoc := CLR_WHITE, nClrPFoc := CLR_BLUE,  nClrGrid := CLR_BLACK ,;
         lVScroll := .t., lHScroll := .t.,;
         nClrText := CLR_BLACK, nClrPane := CLR_WHITE,;
         lBorder := .t., nLinesHdr := 1, lBar := .f., cAlias := "ARRAY",;
         lNoHilite := .f., lFoots := .f., lEditLine := .f.,;
         lFastDef := .f.


   ::nId   := nId

   ::oWnd       = oDlg
   ::lBar       = lBar
   ::lIsCreate  := .f.
   ::lMdiChild  := .f.

   ::bAction    = bAction
   ::bChange    = bChange
   ::bRClicked  = bRClicked

   If oFont == nil
      DEFINE FONT ::oFont NAME "Ms Sans Serif" SIZE 6, 12
      ::lMakeFont := .t.
   else
      ::oFont := oFont
      ::lMakeFont := .f.
   endif

   if nHRow == nil
      ::nHRow := abs(::oFont:nHeight)  + 8
   else
      ::nHRow      = nHRow
   endif

   ::aoColumns  = {}
  *::aCells     = nil
   ::aBrushes   = {}
   ::aColors    = {}
   ::aPens      = {}
   ::aControls  = {}

   ::cAlias      = upper(cAlias)

   ::nClrText := nClrText
   ::nClrPane := nClrPane

   //27-07-97
   ::aFonts     = {}
   ::aTxtColors = {}
   ::RegisFont( ::oFont )
   ::RegisTxtC( ::nClrText )

   // add  27/08/97
   ::lTotalizar  := .t.

   ::lAdd         = .f.

   ::SetColor( nClrText, nClrPane )
   ::oBrush := TBrush():New(,nClrPane)

   ::RegisColor( nClrText )
   ::RegisColor( nClrPane )

   ::nClrTFoc := nClrTFoc
   ::nClrPFoc := nClrPFoc
   ::nBClrFoc := ::RegisColor( ::nClrPFoc )

   ::lHitTop    = .t.
   ::lHitBottom = .f.
   ::lCaptured  = .f.
   ::lNeedScrl  = .f.
   ::lLastPage  = .f.
   ::lVScroll   = lVScroll
   ::lHScroll   = lHScroll
   ::lEditLine  = lEditLine
   ::lVGrid     = lVGrid
   ::lHGrid     = lHGrid
   ::lGrid      = if ( lVGrid .or. lHGrid, .t., .f. )
   ::lFocused   = .f.
   ::lMChange   = .t.
   ::lBorder    = lBorder
   ::lClrRows   = .f.
   ::lChangeW   = .f.
   ::lNoHilite  = lNoHilite
   ::lFoots     = lFoots
   ::lFastDef   = lFastDef
   ::lNoResizeCol = .f.
   ::lNoDragCol   = .f.
   ::lUpdate   = .t.
   ::lShow1array  = .f.
   ::lFilter    = .f.

   ::lEditting    = .f.

   ::nTimeOut   = 60
   ::nColPos    = 1
   ::nRowPos    = 1
   ::nColScr    = 1
   ::nCols      = 0
   ::nLinesHdr  = nLinesHdr
   ::nAt        = 1
   ::nLeftTxt   = 1

   ::lHeader    = ::nLinesHdr != 0


   ::nClrGrid := nClrGrid
   ::oPenGrid := TPen():New(,,::nClrGrid )

   if upper(::cAlias) # "ARRAY"

      ::bGoTop     = { || ( ::cAlias )->( DbGoTop() ) }
      ::bGoBottom  = { || ( ::cAlias )->( DbGoBottom() ) }
      ::bSkip      = { | n | ( ::cAlias )->( _DbSkipper( n ) ) }
      ::bLogicLen  = {|| (::cAlias)->(::xReccount()) }
      ::nLen       = Eval( ::bLogicLen )

   endif

   ::Register( nOr( CS_VREDRAW, CS_HREDRAW, CS_DBLCLKS ) )

    oDlg:DefControl( Self )

return self


   ******************************************************************
      METHOD AddColumn( oColumna ) CLASS TGrid
   ******************************************************************

      Local n, nLen
      Local nFilas
      Local nColor, nColor1, nColor2, nColor3, nColor4
      Local nFColor
      Local nLines
      Local nAncho, nAlto
      Local oThis := Self
      Local nFont
      Local nAlign, nColumna
      Local cStyleCell := "" // for store the style of the cell

      nColor   := 2        // backcolor column
      nColor1  := 2        // backcolor column with codeblock
      nColor2  := 1        // color for paint the active cell ( pen )
      nColor3  := 1        // color for paint the active cell ( pen )
                           // with codeblock
      nColor4  := 1        // text color
      nFColor  := 2        // backcolor foot
      nFont    := 1        // column font
      nAlign   := 0        // alignament for drawing text


      ::nCols ++

      if ::nLinesHdr > 0

         if oColumna:oHeader == nil
            oColumna:oHeader := THdrGrid():New()
         endif

         if oColumna:oHeader:aTitles != nil

            nLen := Len( oColumna:oHeader:aTitles )

         else
            oColumna:oHeader:aTitles := array( ::nLinesHdr )
            nLen := ::nLinesHdr
         endif

         For n := 1 to ::nLinesHdr

             if  n > nLen
                 aadd( oColumna:oHeader:aTitles , "" )
             else
                 if oColumna:oHeader:aTitles [ n ] == nil
                    oColumna:oHeader:aTitles [ n ] := ""
                 endif
             endif
         next

         * - comprobar aGrids de las cabeceras

         if oColumna:oHeader:aGrids != nil

            nLen := Len( oColumna:oHeader:aGrids )

         else
            oColumna:oHeader:aGrids := array( ::nLinesHdr )
            nLen := ::nLinesHdr
         endif

         For n := 1 to ::nLinesHdr

             if  n > nLen
                 aadd( oColumna:oHeader:aGrids , "" )
             else
                 if oColumna:oHeader:aGrids [ n ] == nil
                    oColumna:oHeader:aGrids [ n ] := ""
                 endif
             endif

         next


         *- registrar el color de fondo de las lineas de cabecera

         if oColumna:oHeader:aClrPane != nil

            nLen := Len( oColumna:oHeader:aClrPane )

            if nLen  < ::nLinesHdr

               for n := nLen To ::nLinesHdr
                   aadd( oColumna:oHeader:aClrPane , ::nClrPane )
               next

            endif

         else

            oColumna:oHeader:aClrPane := array( ::nLinesHdr )

         endif

         oColumna:oHeader:anClrPane  := array( ::nLinesHdr )

         for n := 1 to ::nLinesHdr

             if oColumna:oHeader:aClrPane[ n ] == nil

                // si no he especificado el color de fondo
                // le asignamos el color de fondo del grid
                // que es el primero que registramos al crear el grid

                oColumna:oHeader:anClrPane[ n ] := 2

             else

                // si se especifica el color lo registramos

                oColumna:oHeader:anClrPane[ n ] := ::RegisColor( oColumna:oHeader:aClrPane[ n ] )

             endif

         next

         * - Cargar los bitmaps si los hubiese

         if oColumna:oHeader:aBitmaps != nil

            if Len( oColumna:oHeader:aBitmaps ) < ::nLinesHdr
               asize(oColumna:oHeader:aBitmaps ,::nLinesHdr)
            endif

         else

            oColumna:oHeader:aBitmaps := array( ::nLinesHdr )

         endif


         oColumna:oHeader:aHBitmaps  := array( ::nLinesHdr )
         oColumna:oHeader:aSizesBmps := array( ::nLinesHdr )

         ::GetDC()
         for n := 1 to ::nLinesHdr

             if oColumna:oHeader:aBitmaps[ n ] # nil

                if "." $ oColumna:oHeader:aBitmaps[ n ]

                   // es un fichero .BMP
                   oColumna:oHeader:aHBitmaps[ n ] := ;
                       PalBmpRead( ::hDC, oColumna:oHeader:aBitmaps[ n ] )

                else

                   // es un recurso
                   oColumna:oHeader:aHBitmaps[ n ] := ;
                       PalBmpLoad( oColumna:oHeader:aBitmaps[ n ] )

                endif

                if oColumna:oHeader:aHBitmaps[ n ] != 0
                   PalBmpNew( ::hWnd, oColumna:oHeader:aHBitmaps[ n ] )
                endif

                nAncho := nBmpWidth  (oColumna:oHeader:aHBitmaps[ n ])
                nAlto  := nBmpHeight (oColumna:oHeader:aHBitmaps[ n ])

                oColumna:oHeader:aSizesBmps[ n ] := { nAncho, nAlto,;
                                                      int(nAncho/2),;
                                                      int(nAlto/2 ) }
             else

                oColumna:oHeader:aSizesBmps[ n ] := { 0, 0, 0,0 }

             endif


         next


         if oColumna:oHeader:aoFont != nil
            if Len( oColumna:oHeader:aoFont ) != ::nLinesHdr
               asize(oColumna:oHeader:aoFont ,::nLinesHdr)
            endif
         else
            oColumna:oHeader:aoFont := array( ::nLinesHdr )
         endif

         ::ReleaseDC()
         ::hDC := nil

         for n := 1 to ::nLinesHdr

             if oColumna:oHeader:aoFont[ n ] == nil
                oColumna:oHeader:aoFont[ n ] := ::oFont
             endif

         next

         if oColumna:oHeader:aClrText != nil
            if Len( oColumna:oHeader:aClrText ) < ::nLinesHdr
               asize(oColumna:oHeader:aClrText ,::nLinesHdr)
            endif
         else
            oColumna:oHeader:aClrText := array( ::nLinesHdr )
         endif

         for n := 1 to ::nLinesHdr

             if oColumna:oHeader:aClrText[ n ] == nil
                oColumna:oHeader:aClrText[ n ] := ::nClrText
             endif

         next

      endif

      if oColumna:uDato != nil

         if valtype( oColumna:uDato ) == "B"

            oColumna:bBlock := oColumna:uDato

         else

            if upper(::cAlias) == "ARRAY"
               if ::lCompatible
                  oColumna:bBlock := ::DameBlock( ::aTabla )
               else
                  if valtype( ::aTabla[ oColumna:uDato ] ) != "A"
                     ::lShow1Array := .t.
                     oColumna:bBlock := ::DameBlock( ::aTabla )
                  else
                     oColumna:bBlock :=  ::DameBlock( ::aTabla[ oColumna:uDato ] )
                  endif
               endif
            else
               oColumna:bBlock :=  & ( "{|u|if(pcount()==0," + oColumna:uDato + "," + oColumna:uDato + ":=u)}" )
            endif

         endif

      else

         oColumna:bBlock := {|| "" }
         oColumna:lEditable := .f.

      endif

      if oColumna:oFoot != nil

         if oColumna:oFoot:nClrPane != nil
            nFColor := ::RegisColor( oColumna:oFoot:nClrPane )
         else
            nFColor := ::RegisColor( ::nClrPane )
         endif

         oColumna:oFoot:nBClrPane := nFColor

         if oColumna:oFoot:nClrText == nil
            oColumna:oFoot:nClrText := ::nClrText
         endif

         if oColumna:oFoot:oFont == nil
            oColumna:oFoot:oFont := ::oFont
         endif

      endif


      //27-07-97
       if ::lIsCreate
          if ::lMdiChild
            * grid rezisable
            nLines := 60
          else
             * the grid not resizable
             nLines := ::nLines
          endif
       else
          nLines := 60
       endif

      oColumna:aColCells := array( nLines )

      // register the column font
      if oColumna:oFont != nil
         nFont  := ::RegisFont( oColumna:oFont )
      else
         // default font of the grid
         nFont  := 1
      endif

      if oColumna:nClrText != nil
         nColor4 := ::RegisTxtC( oColumna:nClrText )
      else
         nColor4 := ::RegisTxtC( ::nClrText )
      endif


      if oColumna:nClrPane != nil
         nColor := ::RegisColor( oColumna:nClrPane )
      else
         nColor := ::RegisColor( ::nClrPane )
      endif

      if oColumna:bColor != nil

         if oColumna:nBClrPane != nil
            nColor1 := ::RegisColor( oColumna:nBClrPane )
         else
            nColor1 := 1
         endif
      else
         nColor1 := 1
      endif

      // 10/10/97
      // ?? el color por codeblock no se puede almacenar en aColCells
      // es un color que se debe almacenar en la columna en un array
      // de colores que se elegir uno u otro en funcin de la evaluacin
      // del codeblock
      // hacer


      // register for the pens colors of the active cells

      if oColumna:nClrText != nil
         nColor2 := ::RegisColor( oColumna:nClrText )
      else
         nColor2 := ::RegisColor( ::nClrText )
      endif

      if oColumna:bColor != nil
         if oColumna:nBClrText != nil
            nColor3 := ::RegisColor( oColumna:nBClrText )
         else
            nColor3 := nColor2
         endif
      else
         nColor3 := nColor2
      endif




      if oColumna:bBitmap != nil
         ::GetDC()
         for n := 1 to len( oColumna:aBitmaps )


                if "." $ oColumna:aBitmaps[ n ]

                   // es un fichero .BMP
                   oColumna:aHBitmaps[ n ] := ;
                       PalBmpRead( ::hDC, oColumna:aBitmaps[ n ] )

                else

                   // es un recurso
                   oColumna:aHBitmaps[ n ] := ;
                       PalBmpLoad( oColumna:aBitmaps[ n ] )

                endif


*                if oColumna:aHBitmaps[ n ] != 0
 *                  PalBmpNew( ::hWnd, oColumna:aHBitmaps[ n ] )
  *              endif

                nAncho := nBmpWidth (oColumna:aHBitmaps[ n ])
                nAlto  := nBmpHeight(oColumna:aHBitmaps[ n ])

                oColumna:aSizesBmps[ n ] := { nAncho, nAlto,;
                                              int(nAncho/2),;
                                              int(nAlto/2 ) }


         next

         ::ReleaseDC()
         ::hDC := nil

      endif

      aadd( ::aoColumns, oColumna )

      nColumna := len( ::aoColumns )

      nAlign :=  ascan( ALINEACION, oColumna:nAjuste )

      cStyleCell  :=  chr( nColor  + 64 )   // GPANE
      cStyleCell  +=  chr( nColor4 + 64 )   // GTEXT
      cStyleCell  +=  chr( nFont   + 64 )   // GFONT
      cStyleCell  +=  chr( nAlign  + 64 )   // GALIGN
      cStyleCell  +=  chr( nColor1 + 64 )   // GBLOCKPANE
      cStyleCell  +=  chr( nColor  + 64 )   // GPENPANE
      cStyleCell  +=  chr( nColor2 + 64 )   // GPENTEXT
      cStyleCell  +=  chr( nColor1 + 64 )   // GPENBPANE
      cStyleCell  +=  chr( nColor3 + 64 )   // GPENBTEXT

      * DT_EXPANDTABS to add to the drawing procces

      for n := 1 to nLines

          ::aoColumns[ nColumna ]:aColCells[ n ] := cStyleCell

      next

      ::MoveCell()

return nil

********************************************
  METHOD nAtCol( nColPixel ) CLASS TGrid
********************************************

   local nColumn := ::nColPos - 1
   local nPos    := 0


      while nPos < nColPixel .and. nColumn < ::nCols
         nPos += ::aoColumns[ nColumn + 1 ]:nWidth
         nColumn++
      end

return nColumn
*******************************************
  METHOD ChangePath( cItem ) CLASS TGrid
*******************************************
Local cPath
Local cChar
Local cTemp
Local cUnidad

cItem := alltrim( cItem )
cChar :=  SUBSTR ( cItem, 1, 1)

::oWnd:cTitle := ::cPath

sysrefresh()

DO CASE
   CASE cChar == "["

        cUnidad := Substr( cItem,3,1)
        ::cPath := nil
        ::Direct( ::cPath, cUnidad )
        return nil

   CASE substr( cItem, 1,2 ) == ".."

        cUnidad := Substr( ::cPath,1,1)
        cTemp := SUBSTR( ::cPath, 1, RAT("\",::cPath) - 1 )
        if cTemp == ""
           cTemp := cUnidad + ":\"
        endif

        ::cPath := cTemp
        ::Direct( ::cPath, cUnidad )
        return nil


   CASE !isupper( cChar) .or. alltrim( cItem ) == "."


        return nil


   otherwise

        if right( ::cPath ,1 ) == "\"
           cTemp := ::cPath +  cItem
        else
           cTemp := ::cPath + "\"+  cItem
        endif

endcase


if file( cTemp + "\CON" )
   ::cPath := cTemp
endif

::Direct( ::cPath, cUnidad )

sysrefresh()

Return nil


*******************************************
  METHOD Cuantas( nWidth ) CLASS TGrid
*******************************************
* cuantas columnas tengo que pintar para que no se me quede feo por la derecha
* al hacer ::goright()

* nWidth es la columna que me voy a comer por la izquierda

* 1 Cual es la ltima que
*    veo entera por la derecha -> ::nRightCol
* 2 dnde se pint?          -> ::nRightRC

* cuento desde ::nRightCol cuantas columnas necesito para completar nWidth

local n, nCont
local nBuffer := 0
local nAncho
local lReturn := .t.

for n := ::nColPos to ::nCols
    nAncho := ::aoColumns[ n ]:nWidth
    nBuffer += nAncho
    if nBuffer >= ::nWidthCli
       ::nRightRC := nBuffer - nAncho
       ::nRightCol := n - 1
       exit
    endif
next

if n == ::nCols + 1
   ::nRightCol := ::nCols
   ::nRightRC  := nBuffer - nAncho
   lReturn := .f.
endif


return lReturn


**********************************************
METHOD DameBlock( aArray )  CLASS TGrid
**********************************************
Local aMiArray := aArray

Return { |n| aMiArray[ n ]  }



   ******************************************************************
       METHOD Default() CLASS TGrid
   ******************************************************************

   Local nHeight, nWidth
   Local aRect
   Local n
   Local nLines

   ::lExist := .t.

   DEFINE SCROLLBAR ::oVScroll VERTICAL OF Self ;
         RANGE 0,0

   DEFINE SCROLLBAR ::oHScroll HORIZONTAL OF Self ;
         RANGE 0,0

   ::oTimeOut := nil

   if ::lHScroll
      ::oHScroll:SetRange(1, Max(::nCols,2) )
   endif

   if ::cTxtFile != nil
      ::oHScroll:SetRange(1, (::nLen := eval( ::bLogicLen ) ) )
   endif

      if ::nHRow > ::nHeight
         ::nHRow := ::nHeight
      endif

      nHeight :=  int ( ( int ( ::nHeight / ::nHRow ) * ::nHRow) + ;
                      if( ::lBorder,1,0) +;
                      if( ::lHScroll, GetSysMetrics( 21 ) , 0 ) +;
                      if( ::lFoots,4,0) )


      nWidth :=  ::nWidth - if ( ::lVScroll, GetSysMetrics( 21 ) , 0 ) -;
                      if( ::lBorder,1,0)

                  * 20 -> SM_CYSCROLL
                  * 21 -> SM_CXSCROLL


       ::SetSize( ::nWidth , nHeight , .f.)

       aRect := GetClientRect( ::hWnd )

       ::nWidthCli  := int(aRect[ 4 ] - aRect[ 2 ])

       ::nHeightCli := int(aRect[ 3 ] - aRect[ 1 ])

       ::nPixHHdr   = ::nLinesHdr * ::nHRow

       if ::lFastDef
          ::SetDbf( ::cAlias )
       endif

       ::AdjCols( 1, nWidth - 1 )

       #ifdef DEMO
          DEFINE TIMER ::oOut INTERVAL  60000 OF ::oWnd ;
                 ACTION (  ::nTime ++, if ( ::nTime == 4,( MsgInfo( OemToAnsi("Version 2.0 Grid ( Demostration )." + CRLF + "CanalFive-97" + CRLF + "C4Grid.lib" + CRLF +"End of demostration") ),::Destroy()),))
          ACTIVATE TIMER ::oOut
       #endif

       If !::lMdiChild .or. !::lIsCreate

          nLines := ::nLines

          for n := 1 to ::nCols

              ASIZE( ::aoColumns[n]:aColCells, nLines )

          next

       endif

       ::hBordeDer  := CreatePen (PS_SOLID, 1, ::nClrActB )
       ::hBordeIz   := CreatePen (PS_SOLID, 1, ::nClrInAB )

return self


****************************************************
METHOD Direct( cPath, cUnidad ) CLASS TGrid
****************************************************

Local cDrives := cDrives()
Local aDir
Local nLen, nLen2, n
Local oCol1, oCol2, oCol3, oCol4, oCol5
Local aTabla
Local lPaint  := Len( ::aoColumns ) > 0
Local nDrives := Len( cDrives )
Local bBlock
Local nCont   := 0
Local aBorrar := {}
Local oThis   := Self

DEFAULT cUnidad := CurDrive()
DEFAULT cPath := cUnidad + ":\" + Curdir ( cUnidad )


if at(":", cPath ) != 0
   cUnidad := substr( cPath, 1, 1 )
else
   cUnidad := CurDrive()
endif


::cPath := cPath

::cPath := rtrim( ::cPath )


::oWnd:cTitle := ::cPath

if Right( ::cPath ,1 ) == "\"
   aDir := DIRECTORY ( ::cPath + "*.*","D" )
else
   aDir := DIRECTORY ( ::cPath + "\*.*","D" )
endif

   nLen := Len ( aDir )

   For n := 1 to nLen

       IF aDir[ n,5 ] != "D"

             aDir [n][1] := Lower ( aDir [n,1] )

       endif

       sysrefresh()

   next

   aDir := ASORT (aDir, iif(aDir[1][1] == ".",3,1) ,, { |x,y| x[1] < y[1] }  )

   for n := 1 to nDrives

       aadd(  aDir , {"[-" + substr( cDrives, n, 1) + "-]","","","","" } )

   next


if ::aTabla == nil


   ::SetArray( aDir, .t. )


       DEFINE COLUMNA oCol1 OF Self DATA 1 WIDTH 110
       DEFINE COLUMNA oCol2 OF Self DATA 2 WIDTH 80 ALIGN RIGHT ;
              PICTURE "999,999,999"
       DEFINE COLUMNA oCol3 OF Self DATA 3 WIDTH 80 ALIGN CENTER
       DEFINE COLUMNA oCol4 OF Self DATA 4 WIDTH 80 ALIGN CENTER
       DEFINE COLUMNA oCol5 OF Self DATA 5 WIDTH 40 ALIGN CENTER

       oCol1:bAction := {|| oThis:ChangePath( ::aTabla[::nAt, 1] ) }

else

   ::ChangeArray( aDir )
   ::nRowPos := 1
   ::MoveCell()
   *::Paint()
   ::Refresh()

endif






Return nil







***********************************
  METHOD Display() CLASS TGrid
***********************************


      if ::lVScroll

         * the function of the API setscrollrange not admit a maximum value
         * bigger than 32767 :-(

         if ::nLen > 32767
            ::oVScroll:SetRange( 1, 2 )
         else
            ::oVScroll:SetRange( 1, ::nLen )
         endif

      endif

      if ::lHScroll
         ::oHScroll:SetRange(1, Max(::nCols,2) )
      endif

   ::BeginPaint()

   ::Paint()

   ::EndPaint()

return 0

*******************************************
METHOD DragBegin( nRow, nCol, nKeyFlags ) CLASS TGrid
*******************************************


   if ! lDragging
      nDragCol  := ::nAtCol( nCol )
      lDragging = .t.
      SetCapture( ::hWnd )
      cursorcatch()
   endif

   if ::bDragBegin != nil
      Eval( ::bDragBegin, nRow, nCol, nKeyFlags, Self )
   endif

return nil

**********************************************
  METHOD DelColumn( nColumn ) CLASS TGrid
**********************************************
Local lRestar := (::nRealCol == ::nCols)

DEFAULT nColumn := 1

if nColumn > ::nCols .or. ::nCols == 0
   return nil
endif

::aoColumns[ nColumn ] := nil
ADEL( ::aoColumns, nColumn )
ASIZE( ::aoColumns, ::nCols - 1 )

//27-07-97
*ADEL( ::aCells, nColumn )
*ASIZE( ::aCells, ::nCols - 1 )

::nCols--

if lRestar
   ::nColScr --
endif


return nil









*********************************************
METHOD Destroy() CLASS TGrid
*********************************************
local n, nLen, nLen2, n2

#ifdef DEMO
   ::oOut:Deactivate()
#endif

::lExist := .f.

nLen := Len( ::aBrushes )
for n := 1 to nLen
    DeleteObject( ::aBrushes[ n ] )
    sysrefresh()
next

nLen := Len( ::aPens )
for n := 1 to nLen
    DeleteObject( ::aPens[ n ] )
    sysrefresh()
next


::oPenGrid:End()

if ::lMakeFont
   ::oFont:End()
endif

::oBrush  :End()


for n := 1 to ::nCols

    if ::aoColumns[n]:aHBitmaps != nil

       nLen2 := Len( ::aoColumns[n]:aHBitmaps )

       for n2 :=  1 to nLen2

           if ::aoColumns[n]:aHBitmaps[n2] != nil
              *DeleteObject(::aoColumns[n]:aHBitmaps[n2])
              PalBmpFree  ( ::aoColumns[n]:aHBitmaps[n2] )
              DeleteObject( ::aoColumns[n]:aHBitmaps[n2]  )
           endif

           sysrefresh()

       next

    endif
    sysrefresh()
next


for n := 1 to ::nCols


    if ::aoColumns[n]:oHeader != nil

       if ::aoColumns[n]:oHeader:aHBitmaps != nil

          nLen2 := Len( ::aoColumns[n]:oHeader:aHBitmaps )

          for n2 :=  1 to nLen2

              if ::aoColumns[n]:oHeader:aHBitmaps[n2] != nil
                 PalBmpFree  ( ::aoColumns[n]:oHeader:aHBitmaps[n2] )
                 DeleteObject(::aoColumns[n]:oHeader:aHBitmaps[n2]  )
              endif

              sysrefresh()

          next

       endif
    endif
    sysrefresh()
next

DeleteObject( ::hBordeIz  )
DeleteObject( ::hBordeDer )


  if ::oBrush != nil           //    add 27-08-97
     ::oBrush:End()            //    this staments are the calls to the
  endif                        //    method Destroy of super:Destroy()
                               //    I can not call directly to the
  ::oVScroll:Destroy()         //    the super:destroy() because it cause
  ::oHScroll:Destroy()         //    the destroy involuntary of the oFont.
                               //
  if ! Empty( ::hWnd )         //
     ::UnLink()                //
  endif                        //
                               //
  ::hWnd = 0                   //
                               //

   memory( -1 )

Return nil     // Super:Destroy()














































*********************************************
METHOD RefreshFeet() CLASS TGrid
*********************************************

// If you edit a register out of the grid and some columns are feet with
// totals you must call to this method to update the totals.
// The pointer will be located at the top of the dbf.

::TotalCols()
::GoTop()

Return nil




*********************************************
METHOD Reset() CLASS TGrid
*********************************************
local n
Local nCols := ::nCols

for n := nCols to 1 step -1
    ::DelColumn(n)
    sysrefresh()
next

Return nil


****************************************************
METHOD FillFont( nRow, nCol, oFont ) CLASS TGrid
****************************************************
local n
local nLine
Local nFont


nLine := 60

//27-07-97
nFont := ::RegisFont( oFont )


if nCol != nil

    For n := 1 TO nLine

        ::SetValue( nCol, n, GFONT, nFont )

    Next

else

   For n := 1 to ::nCols
       ::SetValue( n, nRow, GFONT, nFont )
   Next

   ::lClrRows := .t.

endif

Return nil


***************************************************************************
   METHOD FillStep( nClrText, nClrPane, lRow, nIni, nStep, nIni2, nStep2,;
                    anLessRows, anLessCols ) CLASS TGrid
***************************************************************************

Local nClrPane1, nClrText1
local nClrPane2, nClrText2

local nClrText3 // registered text color

local nLen, nRow, nCol
local nRowIni, nColIni
local nStepRows, nStepCols

local nLines


DEFAULT nStep := 2, nStep2 := 1, nIni := 1, nIni2 := 1

if ::lIsCreate
   //13-11-97
   if ::lMdiChild
      * grid rezisable
      nLines := 60
   else
      * the grid not resizable
      nLines := ::nLines
   endif
else
   nLines := 60 //::nLines
endif

if lRow
   nStepRows :=  nStep
   nStepCols :=  nStep2
else
   nStepRows :=  nStep2
   nStepCols :=  nStep
endif

if lRow
   nColIni :=  nIni2
   nRowIni :=  nIni
else
   nColIni :=  nIni
   nRowIni :=  nIni2
endif

if nClrPane != nil
   nClrPane   := ::RegisColor( nClrPane )
   ::lClrRows := .t.
endif

if nClrText != nil
   nClrText1  := ::RegisColor( nClrText )
   nClrtext3  := ::RegisTxtC ( nClrText )
   ::lClrRows := .t.
endif


For nCol := nColIni to ::nCols  STEP nStepCols

    if anLessCols != nil
       if ascan( anLessCols, nCol ) != 0
          loop
       endif
    endif

    For nRow := nRowIni TO nLines STEP nStepRows

        if anLessRows != nil
           if ascan( anLessRows, nRow ) != 0
              loop
           endif
        endif


        if nClrPane != nil

           ::SetValue( nCol, nRow, GPANE,    nClrPane )
           ::SetValue( nCol, nRow, GPENPANE, nClrPane )

        endif

        if nClrText != nil

           ::SetValue( nCol, nRow, GTEXT,    nClrText3 )
           ::SetValue( nCol, nRow, GPENTEXT, nClrText1 )

        endif

    Next

Next

Return nil


***********************************************************
   METHOD GetData( nCol )
***********************************************************
Local uReturn

    if upper(::cAlias) == "ARRAY"
       if ::lCompatible
          uReturn := eval( ::aoColumns[ nCol ]:bBlock , ::nAt ) [::aoColumns[ nCol ]:uDato ]
       else
          uReturn := eval( ::aoColumns[ nCol ]:bBlock , ::nAt )
       endif
    else
       uReturn := eval( ::aoColumns[ nCol ]:bBlock  )
    endif


Return uReturn

***********************************************************
   METHOD GetColSizes() CLASS TGrid
***********************************************************

   local aColSizes := {}

   aeval( ::aoColumns, {|x| aadd( aColsizes, x:nWidth ) } )

return aColsizes

************************************************************
METHOD GoUp( lFromPage ) CLASS TGrid
************************************************************

   local nSkipped
   local nLines := ::nLines
   local lSalto := .f.

   DEFAULT lFromPage := .f.

   * lFromPage es un parametro que me indica si esta llamada viene
   * de pageup

   if ::nLen <  1 .or. ::nCols < 1
      return nil
   endif

   if ! ::lHitTop

      if !lFromPage
         if ::lBar
            ::PaintLine()
         else
            ::PaintCell(.t.)
         endif
      endif


      if ::Skip( -1 ) == -1

         lSalto := .t.

         ::lHitBottom = .f.

         if ::nRowPos >  1

            ::nRowPos--
            ::MoveCell( GUP )

            if !lFromPage
               if ::lBar
                  ::PaintLine( ,,,.t.)
               endif
            endif

         else

            if ::nRows2Scr < nLines
               ::nRows2Scr++
            endif

            If !::lClrRows
               if !lFromPage
                  xVScrll( ::hWnd, -1, ::nHRow , nLines + ::nLinesHdr, ::lHeader, ::nLinesHdr * ::nHRow  )
                  ::PaintLine(,,,::lBar)
               endif
            else
               ::nRowPos := nLines
               ::MoveCell()
               if !lFromPage
                  ::PaintDatos()
                  if ::lFoots
                     ::PaintFoots()
                  endif
               endif
            endif

         endif

      else

         MsgBeep( -1 )
         ::lHitTop = .t.

         if ::nRowPos > 1
            ::nRowPos := 1
            ::Refresh()
         endif


         if !lFromPage
            if ::lBar
               ::PaintLine(,,,.t.)
            endif
         endif

      endif

      if !lFromPage
         ::PaintCell()

         if ::lVScroll
            ::oVScroll:GoUp()
         endif

         if ::bChange != nil .and. lSalto
            Eval( ::bChange, Self )
         endif
      endif

   endif

return nil

//----------------------------------------------------------------------------//
*********************************
METHOD GoDown( lFromPage ) CLASS TGrid
*********************************

   local nSkipped
   local nLines := ::nLines
   local lSalto := .f.

   DEFAULT lFromPage := .f.

   * lFromPage es un parametro que me indica si esta llamada viene
   * de pagedown

   if ::nLen < 1 .or. ::nCols < 1
      return nil
   endif


   if ! ::lHitBottom

      if !lFromPage

         if ::lBar
            ::PaintLine()
         else
            ::PaintCell(.t.)
         endif

      endif

      if ::Skip( 1 ) == 1

         lSalto := .t.
         ::lHitTop = .f.

         if ::nRowPos < nLines

            ::nRowPos++
            ::MoveCell( GDOWN )
            if !lFromPage
               if ::lBar
                  ::Paintline(,,,.t.)
               endif
            endif

         else

            * pasa del final de la p gina

            If !::lClrRows
               if !lFromPage
                  * no estoy paginando
                  xVScrll( ::hWnd, 1, ::nHRow, nLines + ::nLinesHdr, ::lHeader, ::nLinesHdr * ::nHRow )
                  ::PaintLine(,,,::lBar )
               else
                 ::nRowPos := 1
                 ::MoveCell()
               endif
            else
               ::nRowPos := 1
               ::MoveCell()
               if !lFromPage
                  ::PaintDatos()
                  if ::lFoots
                     ::PaintFoots()
                  endif
               endif
            endif

         endif
      else

         MsgBeep( -1 )
         ::lHitBottom = .t.

         if !lFromPage
            if ::lBar
               ::PaintLine(,,,.t.)
            endif
         endif
      endif

      if !lFromPage
         ::PaintCell()

         if ::lVScroll
            ::oVScroll:GoDown()
         endif

         if ::bChange != nil .and. lSalto
            Eval( ::bChange, Self )
          endif

      endif
   endif

return nil

//---------------------------------------------------------------------------//

METHOD GoLeft( lVisible )  CLASS TGrid

DEFAULT lVisible := .t.

if ::nCols < 1
    Return nil
endif


if ::cTxtFile != nil
    ::nLeftTxt -= 5
    if ::nLeftTxt < 1
       ::nLeftTxt := 1
       return nil
    endif
    ::PaintDatos()
    return nil
endif

// nColScr is the relative column where is the cell active, respect of the
// left of the grid.

If ::nColPos == 1 .and. ::nColScr == 1
    Return nil
endif


If lVisible .and. !::lBar
    ::PaintCell(.t.)
endif

::nColScr --

if ::nColScr < 1

    ::nColScr := 1


    ::nColPos--

    if ::nColPos < 1
       ::nColPos := 1
    endif


    ::nLeftCell  := 0
    ::nRightCell := ::aoColumns[ ::nColPos ]:nWidth

    if lVisible

       xHScrll(::hWnd, ::nRightCell )

       ::Paint (::nColPos, 0, 1 )    //1

    else


       ::Paint()

    endif

else

    ::MoveCell( GLEFT )

    if lVisible
       ::PaintCell()
    endif

endif

::MoveCell()

if ::lHScroll .and. lVisible
    ::oHScroll:GoUp()
endif



return nil

//---------------------------------------------------------------------------//
****************************
METHOD GoRight() CLASS TGrid
****************************

local lRepaint := .f.
local nLen := ::nCols
local nAcum := 0
local nPorRight

// hay que hacer goright() hasta que mi celda quepa entera

if ::nCols < 1
    Return nil
endif

if ::cTxtFile != nil
    ::nLeftTxt += 5
    ::PaintDatos()
    return nil
endif





if !::lBar

    if ::nRealCol < nLen
       ::PaintCell(.t.)    // borro la posicin del cell
       ::nColScr ++
       ::MoveCell( GRIGHT )
    else
       Return nil
    endif

else
    * voy a quitar una columna de la izda y pintar tantas
    * columnas a la derecha como necesite

    if ::nColPos == nLen
       Tone(50,0.001)
       Return nil
    endif

    nAcum := ::aoColumns[ ::nColPos ]:nWidth

    if !::Cuantas( nAcum )
       return nil
    endif
    ::nColScr --
    ::nColPos ++
    ::lNeedScrl := .t.
    xHScrll( ::hWnd, -nAcum )

    ::Paint( ::nRightCol + 1 , ::nRightRC - nAcum  )

    Return nil

endif

     * va a pillar fuera ?

do while ::nRightCell > ::nWidthCli


    ::nLeftCell  -= ::aoColumns[ ::nColPos ]:nWidth

    nAcum += ::aoColumns[ ::nColPos ]:nWidth

    ::nColPos++
    ::nColScr--

    ::nRightCell := ::nLeftCell + ::aoColumns[ ::nRealCol ]:nWidth

    lRepaint := .t.

enddo

if ::nRealCol == nLen
    ::nRightCell := ::nWidthCli
endif

If !lRepaint

    ::PaintCell()
    ::lNeedScrl := .f.

else

    ::lNeedScrl := .t.
    xHScrll( ::hWnd, -nAcum )

    ::Paint( ::nRealCol , ::nLeftCell )

endif

if ::lHScroll
    ::oHScroll:GoDown()
endif


return nil

//----------------------------------------------------------------------------//





METHOD GoTop()  CLASS TGrid

   local nLines := ::nLines


   if ( ::nLen := Eval( ::bLogicLen ) ) < 1
      return nil
   endif

   if ! ::lHitTop

      Eval( ::bGoTop )
      ::lHitBottom = .f.

      * borro el cell
      * 25-02-1998 V 2.0N
      if ::lBar
         ::PaintLine( ,,,.f. )
      else
         ::PaintCell( .t. )
      endif

      ::nRowPos = 1
      ::MoveCell()

      if ::nLen <= nLines
         * 25-02-1998 V 2.0N
         if ::lBar
            ::PaintLine( ,,,.t. )
         else
            ::PaintCell()
         endif
      else
         *::Refresh( .f. )
         ::PaintDatos( , , ,.f.)
      endif
      if ::lVScroll
         ::oVScroll:GoTop()
      endif
      if ::bChange != nil
         Eval( ::bChange, Self )
      endif
   endif
   sysrefresh()
   ::lHitTop := .t.

return nil

//----------------------------------------------------------------------------//
********************************
METHOD GoBottom() CLASS TGrid
********************************

   local nSkipped
   local nLines := ::nLines
   local n, nEn
   local nLast


   if ( ::nLen := Eval( ::bLogicLen ) ) < 1
      return nil
   endif

   if ! ::lHitBottom

      ::lHitBottom = .t.
      ::lHitTop    = .f.

      * 25-02-1998 V 2.0N
      if ::lBar
         ::PaintLine( ,,,.f.)
      else
         ::PaintCell( .t. )
      endif

      Eval( ::bGoBottom )

      nEn := ::nLen % nLines

      if ::cAlias != "ARRAY"
         ::nCalcRow()
      else
      endif

      ::MoveCell()

      if ::nLen > nLines
         *04-01-1998
         *::Refresh(.f.)
         ::PaintDatos(,,,.f.)
      endif

      ::lLastPage := .t.


      ::PaintCell()

      if ::lBar
         ::PaintLine(,,,.t.)
      endif


      if ::lVScroll
         ::oVScroll:GoBottom()
      endif
      if ::bChange != nil
         Eval( ::bChange, Self )
      endif

   endif

return nil

//----------------------------------------------------------------------------//

***************************************************
METHOD HScroll( nWParam, nLParam ) CLASS TGrid
***************************************************

   if GetFocus() != ::hWnd
      SetFocus( ::hWnd )
   endif

   do case
      case nWParam == SB_LINEUP
           ::GoLeft()

      case nWParam == SB_LINEDOWN
           ::GoRight()

      case nWParam == SB_PAGEUP
           ::GoLeft()

      case nWParam == SB_PAGEDOWN
           ::GoRight()

      case nWParam == SB_THUMBPOSITION

           * Bug fixed 05-august-1997
           * I did not updated this variable in the calculation
           * of the new position.
           * No actualice esta variable en el calculo
           * de la nueva posicin

                ::nColScr := 1

           ::nColPos := nLParam
           ::oHScroll:SetPos( nLParam )
           ::Refresh()

      otherwise
           return nil
   endcase

return 0

*****************************************************************
METHOD LDblClick( nRow, nCol, nKeyFlags, lVk_ret ) CLASS TGrid
*****************************************************************

   local nClickRow
   local oDlg, oBtn, oCancel           //, oGet
   local nTop, nLeft, nBottom, nRight, nWidth
   local oThis := Self
   local uVar, uVal
   local aPoint
   local oBrush
   local nLen := ::nCols
   local lCancel := .t.
   local nOldVal
   local oFoot, nOldFoot
   local nColumn, cFilename
   local oMomento
   Local areturn
   Local lRefresh := .f.
   Local nOldColPos, nOldColScr
   Local n

   eval( ::aoColumns[ ::nRealCol ]:bWhen )
	 
   if ::lEditting
      Tone(1000,1)
      return 0
   endif

   *DO while ::lEditting
   *
   *   lRefresh := .t.
   *   TONE(1000,1)
   *
   *ENDDO

   IF lRefresh
      ::Refresh()
   ENDIF


   if ::lNoHilite .or. ::nCols < 1
      return nil
   endif

   DEFAULT nRow := ::nTopCell  + 4
   DEFAULT nCol := ::nLeftCell + 4
   DEFAULT lVk_ret := .f.


   if ::nLen < 1 .or. ;
      ( ::lFoots .and. nRow > ::nHeight - (::nHRow + 6 + if(::lHScroll, GetSysMetrics(21),0) ))
      return nil
   endif

   nClickRow := ::nWRow( nRow )

   if nClickRow > ::nRows2Scr .and. !lVk_ret
      tone(3000, 1)
      tone(1000, 1)
      tone(50,0.01)
      return nil
   endif

   nColumn := ::nAtCol( nCol )

   if empty( nColumn )
      nColumn := 1
   endif

   If nRow < ::nPixHHdr .and. ::nLinesHdr != 0
      if nColumn != 0
         if ::aoColumns[ nColumn ]:oHeader:  bAction != nil
            eval( ::aoColumns[ nColumn ]:oHeader:bAction, nColumn )
         endif
      endif
      Return nil
   endif


   if ::aoColumns[ nColumn ]:bAction != nil
      eval( ::aoColumns[ nColumn ]:bAction, self )
      *11-02-98
      if ::lBar
         ::PaintLine(,,,.t.)
      else
         ::PaintCell()
      endif
      return nil
   endif

   if ::bAction != nil
      eval( ::bAction, self )
      return nil
   endif

   *::lEditting := .t.

   if !::aoColumns[ ::nRealCol ]:lEditable
      if ::lEditLine
         if ::nRealCol < ::nCols
            For n := ::nRealCol to ::nCols
               if !::aoColumns[n]:lEditable
                  ::GoRight()
               else
                  exit
               endif
            next n
         endif
      else
         Msgbeep()
         ::lEditting := .f.
         return nil
      endif
   endif

   if !::aoColumns[ ::nRealCol ]:lEditable
      ::lEditting := .f.
      Return nil
   endif


   DO

      ::lEditting := .t.

      oFoot := ::aoColumns[ ::nRealCol ]:oFoot

      if oFoot != nil
         nOldFoot := oFoot:nAcum
      endif

      *::oFont:nCount ++

      // edito las columnas
      *nTop    := (( nClickRow + ::nLinesHdr - 1) * ::nHRow) - 1
      *nLeft   := ::nLeftCell

      nTop     := ::nTopCell - 1
      nLeft    := ::nLeftCell

      if ::nRealCol == nLen
         nWidth := ::nWidthCli - nLeft
      else
         nWidth  := ::nRightCell - ::nLeftCell
      endif

      aPoint :=  { nTop, nLeft }

      ClientToScreen( ::hWnd, aPoint )

      if aPoint[1] == nTop
         aPoint := ClientToScreen( ::hWnd, aPoint )
      endif

      nTop  := aPoint[1]
      nLeft := aPoint[2] - 1


      nBottom := nTop + ::nHRow + 1
      nRight  := nLeft + nWidth

      if nClickRow > 0 .and. nLen > 0 .and. nRow > ::nPixHHdr .and. ;
         if( ::lFoots, nRow < ::nHeightCli - ::nHRow - 4 ,.t.)

         if upper(::cAlias) == "ARRAY"
            if ::lCompatible
               uVar := eval( ::aoColumns[ ::nRealCol ]:bBlock, ::nAt )[ ::aoColumns[ ::nRealCol ]:uDato ]
            else
               uVar := eval( ::aoColumns[ ::nRealCol ]:bBlock, ::nAt )
            endif
         else
            uVar := eval( ::aoColumns[ ::nRealCol ]:bBlock )

            if !( ::cAlias )->( RLock() )

               MsgStop( MSG_LOCKED, TITLE_LOCKED )
               ::lEditting := .f.
               return nil
            endif

         endif

         // para actualizar los pies
         nOldVal := uVar

      else

          *::oFont:nCount --
          ::lEditting := .f.
          return nil

      endif

/*    Ricardo Paton
      if !eval( ::aoColumns[ ::nRealCol ]:bWhen, uVar )

         if upper(::cAlias) != "ARRAY"
            ( ::cAlias ) ->( dbunlock())
         endif

          *MsgAlert(::aoColumns[ ::nRealCol ]:cMsgWhen, "When" )

          ::lEditting := .f.
          return nil
      endif
*/
      if oBrush == nil
         oBrush := TBrush():New("NULL")
      endif

      /*
      if ::lEdAnyKey .and. !empty( ::nLastKey )

         do case
            case valtype( uVar ) == "C" .or. valtype ( uVar ) == "M"

                 uVar := PADR(chr( ::nLastKey ), len( uVar ) )

            case valtype( uVar ) == "N"

                 if isalpha( chr( ::nLastKey ) )
                    exit
                 else
                    uVar := val( str( val( chr( ::nLastKey ) ), len( str( uVar ) ) ) )
                 endif

            case valtype( uVar ) == "D"

                 uVar := ctod("  /  /    ")
         endcase

      endif
      */
      lCancel := .t.

      DEFINE DIALOG oDlg FROM nTop, nLeft TO nBottom, nRight+ 1 ;
        BRUSH oBrush ;
        STYLE nOR( WS_VISIBLE, WS_POPUP ) PIXEL OF Self

         if ::aoColumns[ ::nRealCol ] : aSelDato != nil
                                                                             
                                                                             
                        *Self:oFont
            @ 0,0 LISTBOX oThis:oGet VAR uVar ;
                  ITEMS ::aoColumns[ ::nRealCol ] : aSelDato ;
                  PIXEL ;
                  SIZE nWidth, ::nHRow FONT ::oFont ;
                  OF oDlg

         else

            IF ::aoColumns[ ::nRealCol ]:nAjuste == 0 .or.;
               ::aoColumns[ ::nRealCol ]:nAjuste == 16 .or. ;
               ::aoColumns[ ::nRealCol ]:nAjuste == 17

               // add 27/08/97 adjust MULTICENTER (17)



               @ 0,0 GET oThis:oGet VAR uVar OF oDlg MULTILINE ;
                     PIXEL SIZE nWidth,::nHRow FONT ::oFont ;
                     ON CHANGE if( nKey == 27,;
                        if ( MsgYesNo( TITLE_UPDATED, MSG_UPDATED  ),;
               (lCancel := oThis:AsignVal( oDlg, othis:oGet, upper(oThis:cAlias) == "ARRAY" , nOldFoot, nOldVal ),.f.),.f.),.t.)

            ELSE

               * 2.0S
               if ::aoColumns[ ::nRealCol ]:cEdPicture != nil
                  @ 0,0 GET oThis:oGet VAR uVar OF oDlg ;
                        PIXEL SIZE nWidth,::nHRow FONT ::oFont  ;
                        PICTURE oThis:aoColumns[ oThis:nRealCol ]:cEdPicture
               else
                  @ 0,0 GET oThis:oGet VAR uVar OF oDlg ;
                        PIXEL SIZE nWidth,::nHRow FONT ::oFont
               endif

               if ::aoColumns[ ::nRealCol ]:lAutoViewBmp
                  oThis:oGet:bRClicked := { |  | cFileName := cGetFile( "*.bmp",;
                       MSG_BMPSELECT ), if ( !empty( cFileName) , oThis:oGet:cText := substr(cFileName,3),) }
               endif
               /*
               if ::lEdAnyKey
                  oThis:oGet:bChange := {| nKey, nFlags, self | ;
                         if( oThis:oGet:oGet:Pos >= len( oThis:oGet:oGet:Buffer),;
                             ( oBtn:SetFocus(),oBtn:Click())  ,) }
               endif
               */
            ENDIF

         endif

         if ::bGetValid != nil .and. ::vKeyGet != nil
            setkey( ::vKeyGet, ::bGetValid )
         else
            * si no vamos a editar con una tecla de control
            * asignamos el codeblock al oGet
            if ::bGetValid != nil
               ::oGet:bValid := ::bGetValid
            endif
         endif

         if nClickRow > 0 .and. nLen > 0

            if upper(::cAlias) == "ARRAY"

               @ 100,100 BUTTON oBtn PROMPT "" OF oDlg SIZE 12, 12 DEFAULT ;
                       ACTION lCancel := ::AsignVal( oDlg, othis:oGet, .t., nOldFoot, nOldVal )


            else

               @ 100,100 BUTTON oBtn PROMPT "" OF oDlg SIZE 12, 12 DEFAULT ;
                       ACTION  lCancel := ::AsignVal( oDlg, othis:oGet, .f., nOldFoot, nOldVal )

            endif
         else
            ? "mirar linea 1679 + o - "
         endif

*--

      ACTIVATE DIALOG oDlg  ;
               ON INIT ( oDlg:Move(nTop, nLeft ),;
                       oThis:oGet:SetSize(nWidth  ,oThis:nHRow     ),;
                       syswait(0.01), if( !oThis:lExist, oDlg:End(),) )


             *if( oThis:lEdAnyKey .and. oThis:oGet:ClassName() == "TGET" .and.;
             *       oThis:nLastKey >= 32, oThis:oGet:SetPos( 2,2),) )

                       * oThis:InitTimeOut( oDlg ) ,;
                       * oGet:bKeyDown := {|| oThis:oTimeOut:End(),oThis:InitTimeOut( oDlg )},;

         if ::bGetValid != nil .and. ::vKeyGet != nil
            setkey( ::vKeyGet, {|| .t.} )
         endif

      *if ::oTimeOut != nil
      *   ::EndTimeOut()
      *endif

     ::oGet := nil

     if !::lExist
        return nil
     endif

     if upper(::cAlias) != "ARRAY"
        ( ::cAlias ) ->( dbunlock())
     endif
     iif(::aoColumns[::nRealCol]:bFinal#nil,eval(::aoColumns[::nRealCol]:bFinal),)

*--
     if ::lEditLine .and. !lCancel

        * versin 2.0R  19-01-1999
        do while .t.

           if ::nRealCol < ::nCols

              ::GoRight()

           else

              nOldColPos := ::nColPos
              nOldColScr := ::nColScr

              * borro la celda activa
              ::PaintCell( .t. )

              * me muevo a la principio de lnea
              ::nColPos := 1
              ::nColScr := 1
              ::MoveCell()
              ::GoDown()

              if ::lHitBottom

                 if ::lAdd
                    if ::bUserAdd != nil
                       eval( ::bUserAdd )
                    else
                       (::cAlias)->(dbAppend())
                    endif
                 else
                    ::PaintCell(.t.)
                    ::nColPos := nOldColPos
                    ::nColScr := nOldColScr
                    ::MoveCell()
                    ::PaintCell()
                    lCancel := .t.
                    exit
                 endif

                 ::lHitBottom := .f.
                 ::Skip( -1 )
                 ::GoDown()

                 *::PaintLine()
                 super:Refresh( .t. )

              else

                 if ::lNeedScrl
                    super:Refresh()
                 endif

              endif

           endif

           if ::aoColumns[ ::nRealCol ]:lEditable
              exit
           endif

        enddo
// Ricardo Patn para lanzar WHEN si la edicin es automtica
   eval( ::aoColumns[ ::nRealCol ]:bWhen )

     endif
     ::lEditting := .f.

   UNTIL !::lEditLine .or. lCancel

   SetFocus( ::hWnd )

  ::lEditting := .f.

return nil


*************************************************************
METHOD AsignVal( oDlg, oGet, lArray, nOldFoot, nOldVal ) CLASS TGrid
*************************************************************
local lCancel := .f.
local uVal
local bBlock
local cClase := oGet:ClassName()
local nAux := 0
local nOldRec
local lRefresh := .f.
Local nPos
Local nOrder


bBlock := ::aoColumns[ ::nRealCol ]:bBlock

do case
   case cClase == "TGET"
        uVal := oGet:VarGet()
   case cClase == "TMULTIGET"
        uVal := oGet:cText
   otherwise

        // if is a Listbox and uVal Is empty crashh.
        // Solved
        // 24-11-97

        nPos := oGet:GetPos()

        if nPos == 0
           lCancel := .t.
           return lCancel
        else
           uVal := oGet:GetSelText()
        endif

endcase

   if eval( ::aoColumns[::nRealCol]:bValid, uVal )

      if lArray
         if ::lCompatible
            ::aTabla [::nAt, ::aoColumns[::nRealCol]:uDato ] := uVal
         else
            if ::lShow1Array
               ::aTabla [::nAt ] := uVal
            else
               ::aTabla [::aoColumns[::nRealCol]:uDato,::nAt ] := uVal
            endif
         endif
      else

         nOrder := (::cAlias) -> (indexOrd())

         if nOrder != 0
            nOldRec := ntxpos(  nOrder , (::cAlias)->(Recno()) )
         endif

         // add 10-12-1997 to refresh the logical index number
         SET ORDER TO 0

             eval( bBlock, uVal )

         SET ORDER TO nOrder

         lRefresh := ::nCalcRow( nOrder, nOldRec )

      endif

      oDlg:End()

      if lRefresh
         ::Refresh()
         ::lHittop    := .f.
         ::lHitBottom := .f.
      else
         ::RefreshLine()
      endif

      if ::aoColumns[::nRealCol]:oFoot != nil .and.;
         ::aoColumns[::nRealCol]:oFoot:cTitle == nil

         ::aoColumns[::nRealCol]:oFoot:nAcum := nOldFoot - nOldVal + uVal
         ::PaintFoots()
         lCancel := .f.
      endif

   else
      oGet:Refresh()
      *MsgAlert(::aoColumns[::nRealCol]:cMsgValid,"Valid")
      lCancel := .t.
   endif



return lCancel




*************************************************************
METHOD LButtonDown( nRow, nCol, nKeyFlags )  CLASS TGrid
*************************************************************


   local nClickRow, nSkipped
   local nColPos := 0
   local oRect, nAtCol
   local nNumCol
   local nCols    := ::nCols
   local lLinea   := .f.
   local nAux
   local nColInit := ::nColPos - 1


   if ::nCols < 1
      return Super:LButtonDown( nRow, nCol, nKeyFlags )
   endif

   //04-01-1998
   *::nLen := eval ( ::bLogicLen )

   ::lMouseDown := .t.

   if ::nLen < 1 .or. ;
      ( ::lFoots .and. nRow > ::nHeight - (::nHRow + 6 + if(::lHScroll, GetSysMetrics(21),0) )) .or.;
      (::lNoDragCol .and. nRow <= ::nPixHHdr)
      return nil
   endif

   ::nOldCol := nColPos

     * bug solved 2.0N  (-2)
   ::nColumn := ::nAtCol( nCol-2 )
   nClickRow = ::nWRow( nRow )


      if !::lNoResizeCol .and. (::lMChange .and. ( nNumCol := AScan( ::GetColSizes(),;
                { | nColumn | nColPos += nColumn,;
                              nColInit++,;
                              nCol >= nColPos - 1 .and. ;
                              nCol <= nColPos + 1 }, ::nColPos ) )  != 0 )

         if nNumCol == nCols
            Return nil
         endif

         if ! ::lCaptured
            ::lCaptured = .t.
            ::Capture()
            ::VertLine( nColPos, nColInit )
         endif

         return nil

      endif

      ::SetFocus()

      if nClickRow < ::nRowCount() + 1 .and. nRow > ::nPixHHdr

         if nClickRow == ::nRowPos .and. ::nOldCol == ::nColumn
            return nil
         endif

         If ::lBar
            if nClickRow == ::nRowPos
               Return nil
            endif
            ::PaintLine()
         else
            ::PaintCell( .t. )
         endif

         if nClickRow > 0
            nSkipped  = ::Skip( nClickRow - ::nRowPos )
            ::nRowPos += nSkipped
            if ::lVScroll
               ::oVScroll:SetPos( ::oVScroll:GetPos() + nSkipped )
            endif
          endif

          nAux := ::nColScr
          ::nColScr := ::nColumn - ::nColPos + 1

         ::MoveCell()

         If ::nRightCell > ::nWidthCli .or. ;
            ::nLeftCell + ::aoColumns[ ::nRealCol ]:nWidth > ::nWidthCli

            if ::lBar
               ::nColScr := nAux
               ::GoRight()
               ::Paint()
            else
               ::GoLeft( .f. )
               ::GoRight()
            endif

         else
            if ::lBar
               ::nColScr := nAux
               ::PaintLine( ,,, .t. )
            else
               ::PaintCell()
            endif

         endif

         * version 2.0N correccin de la posicin de la h scroll.
         ::oHScroll:SetPos( ::nRealCol )

         ::lHitTop = .f.
         ::lHitBottom = .f.


         if ::bChange != nil
            Eval( ::bChange, Self )
         endif

      else


      endif


   if lLinea
      ::VertLine( nColPos, nColInit )
   endif


   Super:LButtonDown( nRow, nCol, nKeyFlags )

return 0

//----------------------------------------------------------------------------//

*******************************************************
METHOD LButtonUp( nRow, nCol, nFlags ) CLASS TGrid
*******************************************************

  Local nColumn

   if ::nCols < 1
      Return Super:LButtonUp( nRow, nCol, nFlags )
   endif


   ::MoveCell()

   nColumn := ::nAtCol( nCol )

   ::lMouseDown := .f.


   if ::lCaptured
      ::lCaptured = .f.
      ReleaseCapture()

      If nCol < ::nOldCol - ::aoColumns[ ::nColumn ]:nWidth .or.;
         nCol > ::nWidthCli .or.;
         nColumn < ::nColumn .or. ::nOldCol == nCol
         ::Paint()
      else
         ::VertLine()
      endif

      ::nOldCol := 0
      ::nColumn := 0

   else
       if lDragging
          lDragging := .f.
          ReleaseCapture()
          ::InsertCol( nColumn, nDragCol )
          nDragCol := 0
          CursorArrow()

       endif

   endif

   Super:LButtonUp( nRow, nCol, nFlags )

return nil



**********************************************
METHOD KeyDown( nKey, nFlags ) CLASS TGrid
**********************************************

   if ::nCols < 1
      return Super:KeyDown( nKey, nFlags )
   endif

   do case
      case nKey == VK_UP

           ::cBuffer := ""

           if ::lNoHilite
              ::PageUp()
           else
              ::GoUp()
           endif

      case nKey == VK_DOWN

           ::cBuffer := ""
           if ::lNoHilite
              ::PageDown()
           else
              ::GoDown()
           endif

      case nKey == VK_LEFT

           ::cBuffer := ""
           ::GoLeft()

      case nKey == VK_RIGHT

           ::cBuffer := ""

           ::GoRight()

      case nKey == VK_HOME

           ::cBuffer := ""
           ::GoTop()

      case nKey == VK_END

           ::cBuffer := ""
           ::GoBottom()

      case nKey == VK_PRIOR

           ::cBuffer := ""
           ::PageUp()

      case nKey == VK_NEXT

           ::cBuffer := ""
           ::PageDown()

      case nKey == VK_F5

           ::cBuffer := ""
           ::Refresh()

      otherwise
           if nKey >= 32 .and. nKey < 256
              /*
              if ::lEdAnyKey
                 ::nLastKey := nKey
                 ::lDblClick( ,,, .t. )
                 return 0
              endif
              */
           endif
           return Super:KeyDown( nKey, nFlags )
   endcase

   if ::bKeyDown != nil
      return Eval( ::bKeyDown, nKey, nFlags )
   endif

return 0

//----------------------------------------------------------------------------//

********************************************
METHOD KeyChar( nKey, nFlags ) CLASS TGrid
********************************************

   if ::nCols < 1
      return Super:KeyChar( nKey, nFlags )
   endif

   do case
      case nKey == VK_PRIOR
           ::PageUp()

      case nKey == VK_NEXT
           ::PageDown()

      case nKey == VK_RETURN

           *if ::lEdAnyKey
           *   ::nLastKey := 0
           *endif

           * version 2.0w 16-01-2000 para no entrar en edicin enbuclada.
           if ::oGet != nil
              return 0
           endif

           if ::bAction != nil
              eval( ::bAction, self )
           else
              ::lDblClick( ,,, .t. )
              return 0
           endif

      otherwise
           return Super:KeyChar( nKey, nFlags )
   endcase

return 0

********************************************************
METHOD MouseMove( nRow, nCol, nKeyFlags ) CLASS TGrid
********************************************************

   local nColPos := 0
   local nNumCol
   local nCols := ::nCols

   if ::nCols < 1
      return Super:MouseMove( nRow, nCol, nKeyFlags )
   endif

   if ::lCaptured
      CursorWE()
      ::VertLine( nCol )
      return 0
   endif

   if nRow > ::nPixHHdr .and. !lDragging
      if !::lNoResizeCol .and. (::lMChange .and. ( nNumCol := AScan( ::GetColSizes(),;
                 { | nColumn | nColPos += nColumn,;
                               nCol >= nColPos - 1 .and. ;
                               nCol <= nColPos + 1 }, ::nColPos ) ) != 0 )

         if nNumCol == nCols .or. nRow < ::nPixHHdr
            Return nil
         endif

         CursorWE()

      else

         Super:MouseMove( nRow, nCol, nKeyFlags )

      endif
  else

      if ::lMouseDown .and. ;
         ( Abs( nRow - ::nLastRow ) > 2 .or. Abs( nCol - ::nLastCol ) > 2 )

         if ::lNoDragCol
            Return 0
         endif

         if ! lDragging
            ::DragBegin( nRow, nCol, nKeyFlags )
         endif
      else

         if nRow < ::nPixHHdr
            if !::lNoDragCol
               CursorHand()
            endif
            return 0
         else
            CursorArrow()
         endif

         return Super:MouseMove( nRow, nCol, nKeyFlags )
      endif

  endif
return 0



*********************************************
  METHOD MoveCell ( nSide ) CLASS TGrid
*********************************************
local nWidth

local nLen := Len ( ::aoColumns )
local n
local aColSizes := ::GetColSizes()

              //local nLen := Len ( ::aFields )

DEFAULT nSide := RESIZE

DO CASE
   CASE nSide == GUP

        ::nTopCell    -= ::nHRow
        ::nBottomCell -= ::nHRow

   CASE nSide == GDOWN

        ::nTopCell    += ::nHRow
        ::nBottomCell += ::nHRow

   CASE nSide == GLEFT

        ::nLeftCell -= ::aoColumns[ ::nRealCol ]:nWidth

        if ::nRealCol == len( ::aoColumns ) .or.;
           ::nLeftCell + ::aoColumns[ ::nRealCol ]:nWidth > ::nWidthCli

           ::nRightCell  := ::nWidthCli

        else

           ::nRightCell  := ::nLeftCell +;
                            ::aoColumns[ ::nRealCol ]:nWidth
        endif


   CASE nSide == GRIGHT

        nOldLeftCell := ::nLeftCell

        ::nLeftCell  := ::nRightCell
        ::nRightCell  := ::nLeftCell + ::aoColumns[ ::nRealCol ]:nWidth


   CASE nSide == RESIZE

        ::nTopCell    := (::nRowPos + ::nLinesHdr - 1) * ::nHRow
        ::nBottomCell := ::nTopCell + ::nHRow

        ::nLeftCell := 0



        aeval( ::aoColumns, { |X| ::nLeftCell += X:nWidth }, ::nColPos, ::nColScr - 1 )


        if ::nRealCol <> nLen
           ::nRightCell  := ::nLeftCell + aColsizes[ ::nRealCol ]
        else
           ::nRightCell  := ::nWidthCli
        endif



ENDCASE


Return nil

***************************************
METHOD PageUp( nLines ) CLASS TGrid
***************************************

   local nSkipped, n, nCount

   DEFAULT nLines := ::nLines

   nCount := 0
   if ::lHitTop
      Return nil
   endif

   for n := 1 to nLines
       ::GoUp(.t.)
       if ::lHitTop
          exit
       endif
       nCount++
   next
   if ::bChange != nil
      eval( ::bChange, self )
   endif

   if ::lVScroll
      ::oVScroll:SetPos( ::oVScroll:GetPos() - nCount )
   endif

   ::PaintDatos()

return nil

//----------------------------------------------------------------------------//
*******************************
METHOD PageDown( nLines ) CLASS TGrid
*******************************
   local nSkipped, n
   local lBottom := .f.
   local nCount := 0

   DEFAULT nLines := ::nLines


   if ::lHitBottom
      Return nil
   endif

   for n := 1 to nLines
       ::GoDown(.t.)
       if ::lHitBottom
          exit
       endif
       nCount++
   next

   if ::bChange != nil
      eval( ::bChange, self )
   endif
   if ::lVScroll
      ::oVScroll:SetPos( ::oVScroll:GetPos() + nCount )
   endif

   ::PaintDatos()

Return nil

**************************************************************
METHOD Paint( nColumna, nLeft, nCols ) CLASS TGrid
**************************************************************


if ::nCols < 1
   Return nil
endif

if ::lTotalizar

   if ::lFoots
      CursorWait()
      ::TotalCols()
   endif

   ::lTotalizar := .f.

endif

::GetDC()

if ::lHeader
   ::PaintHdr()
endif

::PaintDatos( nColumna, nLeft, nCols )

if ::lFoots
   ::PaintFoots()
endif


::ReleaseDC()

::hDC := nil


return nil

**********************************************
METHOD PaintCell( lErase ) CLASS TGrid
**********************************************
local hOldFont
local nRealCol := ::nRealCol
local hOldPen
local hBmp
local nHBmp
local nWBmp
Local hPen, nClrText, nClrPane
local nLeft, nRight
local lHDC := .f.

// lErase es para borrar la seleccin anterior


if ::lBar .or. ::nLen == 0
   Return nil
endif

if ::lNoHilite
   return nil
endif


if ::hDC == nil
   ::GetDC()
   lHDC := .t.
endif


DEFAULT lErase := .f.


// pinto con el color de seleccin




if lErase
   * tengo que borrar el borde


      if ::aoColumns[nRealCol]:bColor != nil

         if eval( ::aoColumns[nRealCol]:bColor, if(upper(::cAlias) == "ARRAY", ::nAt, (::cAlias) -> (Recno()) ) )

            hPen := ::aPens[ ::GetValue( nRealCol, ::nRowPos, GPENBPANE ) ]

         else

            hPen := ::aPens[ ::GetValue( nRealCol, ::nRowPos, GPENPANE ) ]

         endif

      else

         hPen := ::aPens[ ::GetValue( nRealCol, ::nRowPos, GPENPANE ) ]

      endif
else

      if ::aoColumns[nRealCol]:bColor != nil

         if eval( ::aoColumns[nRealCol]:bColor, if(upper(::cAlias) == "ARRAY", ::nAt, (::cAlias) -> ( Recno() ) ) )

            hPen := ::aPens[ ::GetValue( nRealCol, ::nRowPos, GPENBTEXT ) ]

         else

            hPen := ::aPens[ ::GetValue( nRealCol, ::nRowPos, GPENTEXT ) ]

         endif

      else

         hPen := ::aPens[ ::GetValue( nRealCol, ::nRowPos, GPENTEXT ) ]

      endif

endif

hOldPen := SelectObject( ::hDC, hPen )

nLeft  := ::nLeftCell  //- if( ::nLeftCell <= 1 .and. !::lVGrid, 0, 1 )

nRight := ::nRightCell + if( nRealCol == ::nCols .and. !::lVScroll , 1, 0) -;
                         if ( !::lVGrid,1,2)

   Moveto( ::hDC, nLeft , ::nTopCell     )
   Lineto( ::hDC, nRight, ::nTopCell     )
   Lineto( ::hDC, nRight, ::nBottomCell - if( ::lHGrid, 2,1)  )
   Lineto( ::hDC, nLeft , ::nBottomCell - if( ::lHGrid, 2,1) )
   Lineto( ::hDC, nLeft , ::nTopCell        )


SelectObject( ::hDC, hOldPen )

if lHDC
   ::ReleaseDC()
   ::hDC := nil
endif

Return nil

**************************************************************
METHOD PaintDatos( nColumna, nLeft, nCols, lCount ) CLASS TGrid
**************************************************************

local n
local nLines := ::nLines
local nSkiped1 := 0
local nSkiped2 := 0
local nSkiped3 := 0
local hOldFont
local aRect
local lOldHitTop    := ::lHitTop
local lOldHitBottom := ::lHitTop
local lHDC := .f.

DEFAULT lCount := .t.

::nRows2Scr := 1

if lCount
   *04-01-1998
   ::nLen = Eval( ::bLogicLen )
endif

if ::nLen == 0
   Return nil
endif

aRect := GetClientRect( ::hWnd )
::nWidthCli  := int( aRect[ 4 ] - aRect[ 2 ] )

::MoveCell()

If ::hDC == nil
   ::GetDC()
   lHDC := .t.
endif



   if ::nLen > 0

       // situo el puntero en la fila 1 del control
       // y anoto los que salt hacia atr s

       nSkiped1 := ::Skip( 1 - ::nRowPos )

       For n := 1 to nLines

           ::PaintLine ( n, nColumna, nLeft, if( ::lBar, n == ::nRowPos, .f.), nCols )

           nSkiped2 = ::Skip( 1 )
           // si no he conseguido saltar uno

           If nSkiped2 <> 1
              ::lLastPage := .t.
              exit
           else
              ::nRows2Scr ++
           endif

           ::lLastPage := .f.

           nSkiped3 ++

       next

       ::Skip ( -(nSkiped3 + nSkiped1) )

   endif

if ::lLastPage
   Fillrect(::hDC, { ( n + if( ::lHeader, ::nLinesHdr, 0 )) * ::nHRow, 0, ::nHeight, ::nWidthCli},;
                    ::oBrush:hBrush)
   if ::lFoots
      ::PaintFoots()
   endif
endif

if lHDC
   ::ReleaseDC()
   ::hDC := nil
endif

::PaintCell()

return 0


***********************************************
METHOD PaintFoots() CLASS TGrid
***********************************************

local nWidth
local nAcumWidth := 0
local nLen
local nCol   := 0
local nLin
local nCont  := 0
local lSalir := .f.

local nLeft  := 0
local nTop   := - 1
local nBottom := nTop + ::nHRow + 1
local nRight := 0

local hOldPen, hBrush, hOldBrush
local nColor
local nBkColor
local hOldFont
local hFont
local nHFont
local nHScroll :=  GetSysMetrics( 21 )
local nVScroll :=  GetSysMetrics( 20 )
local cValue
local hPen := CreatePen ( PS_SOLID, 2, ::nClrGrid )

local nLines := ::nLines
local lHDC := .f.

nLen := ::nCols



if ::hDC == nil
    ::GetDC()
    lHDC := .t.
endif


nBkColor := SetBkMode( ::hDC, 1 )                 // Transparente
*hOldFont := SelectObject( ::hDC, ::oFont:hFont )


nWidth  := ::nWidth

* primero pinto los fondos y despues pintar los textos
* para poder sobreescribir alguna columna que no tenga
* texto. 'expandir columnas o filas'

nTop    := (::nHRow * (nLines + if( ::lHeader, ::nLinesHdr, 0) ) + 4)
nBottom := nTop + ::nHRow - 3

hOldPen := SelectObject( ::hDC, hPen )

Moveto( ::hDC, 2, nTop - 2 )
Lineto( ::hDC, ::nWidth - if( ::lVScroll, nVScroll, 0) - 2, nTop - 2 )

SelectObject( ::hDC, hOldPen )
DeleteObject( hPen )


for nCol = ::nColPos to nLen

     nCont++

     nAcumWidth += ::aoColumns[ nCol ]:nWidth

     If nAcumWidth >= nWidth
        lSalir := .t.
     endif

     if nCont > 1

        nLeft := nRight + 1

     endif

     if nCol == nLen .or. lSalir .or. nLen == 1
        nRight := nWidth
     else
        nRight := nLeft + ::aoColumns[ nCol ]:nWidth - 1
     endif



     if ::aoColumns[ nCol ]:oFoot != nil

        FillRect  (  ::hDC,{ nTop, nLeft , nBottom  , nRight+ 1},;
            ::aBrushes[ ::aoColumns[ nCol ]:oFoot:nBClrPane ] )

     else

        FillRect  (  ::hDC,{ nTop, nLeft , nBottom  , nRight+ 1},;
            ::aBrushes[ 2 ] )

     endif

     If lSalir
        exit
     endif

next


nCont   := 0
lSalir  := .f.
nRight  := 0
nAcumWidth := 0
nLeft   := 0


for nCol = ::nColPos to nLen

     nCont++

     nAcumWidth += ::aoColumns[ nCol ]:nWidth

     If nAcumWidth >= nWidth
        lSalir := .t.
     endif

     if nCont > 1

        nLeft := nRight + 1

     endif


     if nCol = nLen .or. lSalir .or. nLen == 1
        nRight := nWidth
     else
        nRight := nLeft + ::aoColumns[ nCol ]:nWidth - 1
     endif

     If ::aoColumns[ nCol ]:oFoot   != nil

         hOldFont := SelectObject(::hDC, ::aoColumns[ nCol ]:oFoot:oFont:hFont )
         nColor   := SetTextColor( ::hDC, ::aoColumns[ nCol ]:oFoot:nClrText )

         nHFont   := ::aoColumns[ nCol ]:oFoot:oFont:nHeight

        If ::aoColumns[ nCol ]:oFoot:cTitle != nil

           cValue := ::aoColumns[ nCol ]:oFoot:cTitle

           If ::aoColumns[ nCol ]:lOem
              cValue := OemToAnsi( cValue )
           endif

        else

           if ::aoColumns[ nCol ]:oFoot:nAcum != nil
              cValue := cValToChar(::aoColumns[ nCol ]:oFoot:nAcum)
           else
              cValue := ""
           endif

           if ::aoColumns[ nCol ]:oFoot:cPicture != nil

              *cValue := Transform( cValue, ::aoColumns[ nCol ]:oFoot:cPicture )

              * Bug fixed 04-08-1997 ( NOT cValue.
              *       the value for transform will be
              *               ::aoColumns[ nCol ]:oFoot:nAcum

              cValue := Transform( ::aoColumns[ nCol ]:oFoot:nAcum,;
                                   ::aoColumns[ nCol ]:oFoot:cPicture )
           endif

        endif

         DrawText  ( ::hDC, cValue ,;
                 { nTop+1, nLeft + 3 , nBottom-1  , nRight- 3},;
                 ::aoColumns[nCol]:oFoot:nAjuste +;
                 if (::aoColumns[ nCol ]:oFoot:lSpand, 256,0) )

         SelectObject( ::hDC, hOldFont )

     endif


     If lSalir
        exit
     endif

next

  *
  *********************************

SetBkMode( ::hDC, nBkColor ) // Transparente

SetTextColor( ::hDC, ::nClrText )


if lHDC
   ::ReleaseDC()
   ::hDC := nil
endif

return nil


***********************************************
METHOD PaintHdr() CLASS TGrid
***********************************************

local nWidth
local nAcumWidth := 0
local nLen   := Len ( ::aoColumns )
local nCol   := 0
local nLin
local nCont  := 0
local lSalir := .f.

local nLeft  := 0
local nTop   := - 1
local nBottom := nTop + ::nHRow + 1
local nRight := 0

local nTop1, nLeft1

local hGrayPen, hWhitePen, hOldPen, hBrush, hOldBrush
local nColor
local nBkColor
local hOldFont
local hFont
local nHFont
local nVLeft
local nVScroll :=  GetSysMetrics( 20 )

local nHRow, nTopBmp, nLeftBmp, hBmp, nWBmp, nHBmp

Local nColIni := ::nColPos

local n, n2
local cSide

::nClrInAB  := GetSysColor( COLOR_BTNHIGHLIGHT )
::nClrActB  := GetSysColor( COLOR_BTNSHADOW)

if nOldClrInAB != ::nClrInAB
    if ::hBordeIz != nil
       DeleteObject( ::hBordeIz )
    endif
    ::hBordeIz   := CreatePen (PS_SOLID, 1, ::nClrInAB )
endif

if nOldClrActB != ::nClrInAb
    if ::hBordeDer != nil
       DeleteObject( ::hBordeDer )
    endif
    ::hBordeDer  := CreatePen (PS_SOLID, 1, ::nClrActB )
endif


nLen := ::nCols

nBkColor := SetBkMode( ::hDC, 1 ) // Transparente
hOldFont := SelectObject( ::hDC, ::oFont:hFont )

nWidth  := ::nWidth

* primero pinto los fondos y despues pintar los textos
* para poder sobreescribir alguna columna que no tenga
* texto. 'expandir columnas o filas'

nTop1  := 0

for nCol = nColIni to nLen

     nCont++

     nAcumWidth += ::aoColumns[ nCol ]:nWidth

     If nAcumWidth >= nWidth
        lSalir := .t.
     endif

     if nCont > 1

        nLeft := nRight + 1

     endif

     nLeft1 := nLeft

     if nCol == nLen .or. lSalir .or. nLen == 1
        nRight := nWidth - if ( ::lVScroll, nVScroll,0)
     else
        nRight := nLeft + ::aoColumns[ nCol ]:nWidth - 1
     endif

     for nLin := 1 to ::nLinesHdr

         nTop    := (::nHRow * (nLin - 1)) - 1
         nBottom := nTop + ::nHRow

         FillRect  (  ::hDC,{ nTop, nLeft , nBottom  , nRight+ 1},;
             ::aBrushes[ ::aoColumns[ nCol ]:oHeader:anClrPane[ nLin ] ] )

     next

     if ::aoColumns[ nCol ]:oHeader:lBtnLook .and. nLin == ::nLinesHdr + 1

        ::BtnLook( ::hDC, nTop1, nLeft1, nBottom+1, nRight+1 )

     endif

     If lSalir
        exit
     endif

next


nCont   := 0
lSalir  := .f.
nTop    := - 1
nBottom := nTop + ::nHRow
nRight  := 0
nAcumWidth := 0
nLeft   := 0


for nCol = nColIni to nLen

     nCont++

     nAcumWidth += ::aoColumns[ nCol ]:nWidth

     If nAcumWidth >= nWidth
        lSalir := .t.
     endif

     if nCont > 1

        nLeft := nRight + 1

     endif

     if nCol == nLen .or. lSalir .or. nLen == 1
        nRight := nWidth - if ( ::lVScroll, nVScroll,0) - 4
     else
        nRight := nLeft + ::aoColumns[ nCol ]:nWidth - 1
     endif

     for nLin := 1 to ::nLinesHdr

         nTop    := (::nHRow * (nLin - 1)) - 1

         nBottom := nTop + ::nHRow

         if ::aoColumns[ nCol ]:oHeader:aHBitmaps[ nLin ] != nil

            hBmp   := ::aoColumns[ nCol ]:oHeader:aHBitmaps [ nLin ]
            nHRow  := ::nHRow

            nTopBmp  := eval( ::aoColumns[ nCol ]:oHeader:aBCalcCoor[ ::aoColumns[ nCol ]:oHeader:nAjusteBmp, 1 ] , nTop,  ::aoColumns[ nCol ], nLin, nHRow )
            nLeftBmp := eval( ::aoColumns[ nCol ]:oHeader:aBCalcCoor[ ::aoColumns[ nCol ]:oHeader:nAjusteBmp, 2 ] , nLeft, ::aoColumns[ nCol ], nLin, nHRow )
            nWBmp    := ::aoColumns[ nCol ]:oHeader:aSizesBmps[ nLin, 1 ]
            nHBmp    := ::aoColumns[ nCol ]:oHeader:aSizesBmps[ nLin, 2 ]

            PalBmpDraw( ::hDC, nTopBmp, nLeftBmp, hBmp,  nWBmp, nHBmp )

         endif

        If ::aoColumns[ nCol ]:oHeader != nil .and. ;
           ::aoColumns[ nCol ]:oHeader:aTitles[ nLin ] # nil

            hOldFont := SelectObject(::hDC, ::aoColumns[ nCol ]:oHeader:aoFont[ nLin ]:hFont )
            nColor   := SetTextColor( ::hDC, ::aoColumns[ nCol ]:oHeader:aClrText[ nLin ] )

            nHFont   := ::aoColumns[ nCol ]:oHeader:aoFont[ nLin ]:nHeight


            If ::aoColumns[ nCol ]:oHeader:aoFont[ nLin ]:nEscapement == 0

                  DrawText  ( ::hDC, ::aoColumns[ nCol ]:oHeader:aTitles[ nLin ] ,;
                        { nTop+1, nLeft + 3 , nBottom    , nRight- 1},;
                        ::aoColumns[nCol]:oHeader:nAjuste + ;
                        if (::aoColumns[ nCol ]:oHeader:lSpand, 256,0) )
             else

               ***********************************************************
               * si la escritura no es horizontal tenemos que localizar  *
               * la esquina top-left (horizontal)                        *
               *                                                         *
               *             -->      Ŀ  <----   Ļ                   *
               *           Ŀ  Ļ                    *
               *                                 *
               ***********************************************************

              do case
                 case ::aoColumns[nCol]:oHeader:nAjuste == 40 // BOTTOM_LEFT

                      nVLeft := eval( ::aoColumns[nCol]:oHeader:aBVText[ 1 ],;
                      ::aoColumns[ nCol ]:oHeader:aoFont[ nLin ] )

                 case ::aoColumns[nCol]:oHeader:nAjuste == 42 // BOTTOM_RIGHT

                      nVLeft := eval( ::aoColumns[nCol]:oHeader:aBVText[ 3 ],;
                      ::aoColumns[ nCol ]:oHeader:aoFont[ nLin ], ::aoColumns[nCol] )

                 otherwise

                      nVLeft := eval( ::aoColumns[nCol]:oHeader:aBVText[ 2 ],;
                      ::aoColumns[ nCol ]:oHeader:aoFont[ nLin ], ::aoColumns[nCol] )

              endcase

                  TextOut( ::hDC,  nBottom - int( ::nHRow / 5 ) , nLeft + nVLeft ,;
                      ::aoColumns[ nCol ]:oHeader:aTitles[ nLin ] )

             endif

             SelectObject( ::hDC, hOldFont )
             SetTextColor( ::hDC, nColor   )

        endif

        if !::aoColumns[nCol]:oHeader:lVGrid .and.;
           !::aoColumns[nCol]:oHeader:lHGrid


           for n2 := 1 to len(::aoColumns[nCol]:oHeader:aGrids[ nLin ])

               cSide := ""
               cSide := substr(::aoColumns[nCol]:oHeader:aGrids[ nLin ],n2,1)

               do case
                  case cSide == "N"
                       Moveto( ::hDC, nLeft -1, nTop      )
                       Lineto( ::hDC, nRight  , nTop      )
                  case cSide == "S"
                       Moveto( ::hDC, nLeft -1, nBottom -1  )
                       Lineto( ::hDC, nRight  , nBottom -1  )
                  case cSide == "E"
                       Moveto( ::hDC, nRight, nTop -1)
                       Lineto( ::hDC, nRight, nBottom)
                  case cSide == "W"
                       Moveto( ::hDC, nLeft , nTop -1)
                       Lineto( ::hDC, nLeft , nBottom)
               endcase

           next

        else

           if ::aoColumns[nCol]:oHeader:lVGrid
              Moveto( ::hDC, nLeft -1, nTop -1)
              Lineto( ::hDC, nLeft -1, nBottom)
           endif

           if ::aoColumns[nCol]:oHeader:lHGrid .or. ;
              ( nLin == ::nLinesHdr .and. ::lHGrid )
              Moveto( ::hDC, nLeft -1, nBottom   )
              Lineto( ::hDC, nRight  , nBottom   )
           endif

        endif

     next

     If lSalir
        exit
     endif

     If !Empty(::aControls)
        aeval( ::aControls, {|x| x:Refresh()} )
     endif


next

SetBkMode( ::hDC, nBkColor ) // Transparente



return nil



***********************************************************************
METHOD PaintLine ( nLine, nColumna, nColLeft, lFocus, nCols ) CLASS TGrid
***********************************************************************
Local nTop, nLeft, nBottom, nRight, nTop1, nLeft1
Local nTopBmp, nLeftBmp, nBmp, nHRow
local nCol
local lSalir := .f.

local nAcumWidth := 0

local nCont := 0
local lHDC := .f.
local hOldFont
local nOldText
local nColIni, nColEnd
local hBmp
local nHBmp, nWBmp
local hBrush, hFOnt, hNewFont
local cText, cPicture, nText
local hOldPen
local hBitmap
local nMedH := int(::nHRow/ 2)

local lLastSel := .f.
local nColorEx
local lColorEx := .f.
local hBrushEx

DEFAULT nLine := ::nRowPos, lFocus := .f.


If ::hDC == nil
   lHDC := .t.
   ::GetDC()
endif

SetBkMode( ::hDC, 1 )
SelectObject( ::hDC, ::oPenGrid:hPen )

nTop    :=  ( nLine + ::nLinesHdr - 1) * ::nHRow
nBottom := nTop + ::nHRow

if nColumna <> nil
   nLeft   := nColLeft
   nColIni := nColumna
   nColEnd := if( nCols == 1, nColIni, ::nCols )
   nAcumWidth := nColLeft
else
   nLeft := 0
   nColIni := ::nColPos
   nColEnd := ::nCols
endif

nTop1  := nTop
nLeft1 := nLeft


nText := ::GetValue( nColIni, nLine, GTEXT )
hFont := ::GetValue( nColIni, nLine, GFONT )

hOldFont := SelectObject( ::hDC, hFont )
nOldText := SetTextColor( ::hDC, ::aTxtColors[ ::GetValue( nColIni, nLine, GTEXT ) ] )
hbrush   :=          ::aBrushes[ ::GetValue( nColIni, nLine, GPANE ) ]

For nCol := nColIni TO nColEnd

    lColorEx := .f.

    if ::aoColumns[nCol]:bColorEx != nil

       nColorEx := eval( ::aoColumns[nCol]:bColorEx, nCol )
       hBrushEx := CreateSolidBrush( nColorEx )
       lColorEx := .t.

    else
       if ::aoColumns[nCol]:bColor != nil

          if eval( ::aoColumns[nCol]:bColor, if(upper(::cAlias) == "ARRAY", ::nAt, ) )

             nText := ::aoColumns[nCol]:nBClrText
             nOldText := SetTextColor(::hDC,  nText )
             hBrush := ::aBrushes[ ::GetValue( nCol, nLine, GBLOCKPANE ) ]

          else

             if nText != ::aTxtColors[ ::GetValue( nCol, nLine, GTEXT ) ] .or.;
                lLastSel
                nText := ::aTxtColors[ ::GetValue( nCol, nLine, GTEXT ) ]
                nOldText := SetTextColor( ::hDC, nText )
                lLastSel := .f.
             endif

             hbrush := ::aBrushes[ ::GetValue(  nCol, nLine, GPANE ) ]

          endif

       else

          if nText != ::aTxtColors[ ::GetValue( nCol, nLine, GTEXT ) ] .or.;
             lLastSel

             nText := ::aTxtColors[ ::GetValue( nCol, nLine, GTEXT ) ]
             nOldText := SetTextColor( ::hDC, nText )
             lLastSel := .f.

          endif

          hbrush := ::aBrushes[ ::GetValue(  nCol, nLine, GPANE ) ]

       endif
    endif


    hNewFont := ::aFonts[ ::GetValue( nCol, nLine, GFONT ) ]:hFont

    if hFont != hNewFont

       hFont := hNewFont

       SelectObject( ::hDC, hOldFont )
       hOldFont := SelectObject( ::hDC, hFont )

    endif

    if ::lBar .and. lFocus
       nOldText := SetTextColor( ::hDC, ::nClrTFoc )
       hbrush := ::aBrushes[ ::nBClrFoc ]
    endif

    nCont ++

    nAcumWidth += ::aoColumns[ nCol ]:nWidth

    If nAcumWidth >= ::nWidthCli
       lSalir := .t.
    endif

    if nCont > 1
       nLeft += ::aoColumns[ nCol - 1 ]:nWidth
    endif

    if nCol == ::nCols .or. lSalir .or. ::nCols == 1
       nRight := ::nWidthCli
    else
       nRight  := nLeft + ::aoColumns[ nCol ]:nWidth
    endif

    if lColorEx .and. !( ::lBar .and. lFocus )
       FillRect( ::hDC, {nTop    , nLeft    , nBottom, nRight }, hBrushEx )
    else
       FillRect( ::hDC, {nTop    , nLeft    , nBottom, nRight }, hBrush )
    endif

    if ::lGrid
       hOldPen := SelectObject( ::hDC, ::oPenGrid:hPen )
    endif

    if ::lVGrid
       Moveto( ::hDC, nLeft -1, nTop -1)
       Lineto( ::hDC, nLeft -1, nBottom)

       * si NO estoy en la ultima columna o tengo barra de scroll
       IF nCol != ::nCols .OR. ::lVScroll
          Moveto( ::hDC, nRight -1, nTop -1)
          Lineto( ::hDC, nRight -1, nBottom)
       endif

    endif

    if ::lHGrid
       Moveto( ::hDC, nLeft -1, nBottom -1)
       Lineto( ::hDC, nRight  , nBottom -1)
       if nLine == 1
          Moveto( ::hDC, nLeft -1, nTop -1)
          Lineto( ::hDC, nRight  , nTop -1)
       endif


    endif

    if ::lGrid
       SelectObject( ::hDC, hOldPen )
    endif

    if upper(::cAlias) == "ARRAY"
       if ::lCompatible
          cText := eval( ::aoColumns[ nCol ]:bBlock , ::nAt ) [::aoColumns[ nCol ]:uDato ]
       else
          cText := eval( ::aoColumns[ nCol ]:bBlock , ::nAt )
       endif
    else
       cText := eval( ::aoColumns[ nCol ]:bBlock  )
    endif

    if ::aoColumns[ nCol ]:lAutoViewBmp

       if "." $ cText
          hBitmap  = PalBmpRead( ::hDC, cText )
       else
          hBitmap =  PalBmpLoad( cText )
       endif

       // version
       if hBitmap > 0
          PalBmpNew( ::hDC, hBitmap )
          nHBmp := nBmpHeight( hBitmap )
          nWBmp := nBmpWidth ( hBitmap )

          PalBmpDraw( ::hDC,;
                      nTop+nMedH-nHBmp/2 ,;
                      nLeft+::aoColumns[nCol]:nWidth/2-nWBmp/2,;
                      hBitmap,;
                      nWBmp, nHBmp )

          PalBmpFree( hBitmap )

       endif

    else

       if ::aoColumns[ nCol ]:bBitmap != nil

          nBmp   := eval( ::aoColumns[nCol]:bBitmap )
          hBmp   := ::aoColumns[ nCol ]:aHBitmaps [ nBmp ]
          nHRow  := ::nHRow
          nTopBmp  := eval( ::aoColumns[ nCol ]:aBCalcCoor[ ::aoColumns[ nCol ]:nAjusteBmp, 1 ] , nTop,  ::aoColumns[ nCol ], nBmp, nHRow )
          nLeftBmp := eval( ::aoColumns[ nCol ]:aBCalcCoor[ ::aoColumns[ nCol ]:nAjusteBmp, 2 ] , nLeft, ::aoColumns[ nCol ], nBmp, nHRow )
          nHBmp    := ::aoColumns[ nCol ]:aSizesBmps[ nBmp, 2 ]
          nWBmp    := ::aoColumns[ nCol ]:aSizesBmps[ nBmp, 1 ]

          PalBmpDraw( ::hDC,;
                   nTopBmp ,;
                   nLeftBmp,;
                   hBmp,;
                   nWBmp, nHBmp )


       endif

    endif


    if !::aoColumns[ nCol ]:lNoPaintData

       if ::aoColumns[ nCol ]:cPicture != nil
          cText := Transform( cText, ::aoColumns[ nCol ]:cPicture )
       else
          cText := rtrim(cValToChar( cText ))
       endif

       if ::cTxtFile != nil
          cText := Substr( cText, ::nLeftTxt )
       endif

       If ::aoColumns[ nCol ]:lOem
          cText := OemToAnsi( cText )
       endif

       if ::aoColumns[ nCol ]:bVisualiza != nil
          cText := eval( ::aoColumns[ nCol ]:bVisualiza, cText )
       endif

       DrawText ( ::hDC, cText, {nTop+2, nLeft+4+2, nBottom-2, nRight- 4-2},;
                        ALINEACION[ ::GetValue( nCol, nLine, GALIGN ) ] + DT_EXPANDTABS )

    endif

    if lColorEx
       DeleteObject( hBrushEx )
    endif

    if lSalir
       exit
    endif

next

SelectObject( ::hDC, hOldFont )
SetTextColor( ::hDC, nOldText )





if lhDC
   SetBkMode   ( ::hDC, 0 )
   SelectObject( ::hDC, ::aBrushes[2] )
   ::ReleaseDC()
   ::hDC := nil
endif


return nil




*********************************************
METHOD nWRows() CLASS TGrid
*********************************************

Return int( (::nHeight - if( ::lHScroll, GetSysMetrics( 21 ), 0 ) - ;
            if( ::lBorder,1,0) - if( ::lFoots, 4,0) ) / ::nHRow )


**********************************************
METHOD nWRow( nRow ) CLASS TGrid
**********************************************
Local nReturn

nReturn :=   nRow  / ::nHRow

return   int( nReturn ) - ::nLinesHdr + 1

***********************************************************
METHOD RButtonDown( nRow, nCol, nKeyFlags ) CLASS TGrid
***********************************************************
Local oMenu
Local uVar, cVar
Local oClp
Local nLen := eval( ::bLogicLen )
Local cClpText
Local lPaste := .f.
Local n, nLines
Local bBlock
Local cType, uVal
Local oThis := Self
Local bErr := ErrorBlock ( {| oError | ::Mierror( oError ) } )


  if ::nCols < 1
     Return Super:RButtonDown( nRow, nCol, nKeyFlags )
  endif

  if ::oGet != nil
     ::oGet:End()
     ::oGet := nil
  endif


  ::lButtonDown( nRow, nCol, nKeyFlags, .t. )
  ::lCaptured = .f.
  ReleaseCapture()


   if ::bRClicked != nil
      Eval( ::bRClicked, nRow, nCol, nKeyFlags )
      return nil
   endif

   if nRow > 0 .and. nLen > 0 .and. nRow > ::nPixHHdr .and. ;
      if( ::lFoots, nRow < ::nHeightCli - ::nHRow - 4 ,.t.)

         if upper(::cAlias) == "ARRAY"
            uVar := eval( ::aoColumns[ ::nRealCol ]:bBlock, ::nAt )
         else
            uVar := eval( ::aoColumns[ ::nRealCol ]:bBlock )
         endif

         cVar := alltrim(cValtoChar ( uVar ))

   else
      return nil
   endif

   if ::lUserMenu
      DEFINE CLIPBOARD oClp OF ::oWnd
      ACTIVATE CLIPBOARD oClp

      cClpText := oClp:GetText()

      nLines := mlcount( cClpText )

      MENU oMenu POPUP

      MENUITEM MSGCOPY       ACTION ( oClp:Clear, oClp:SetText( cVar ) )
      SEPARATOR

      if !empty( cClpText)

         if nLines > 1
            MENUITEM MSGPASTE  ACTION lPaste := .t.
            SEPARATOR
            for n := 1 to nLines
                MENUITEM MemoLine( cClpText,80, n )
            next
         else
             MENUITEM MSGPASTE + chr(9) + cClpText ACTION lPaste := .t.
         endif

      endif

      ENDMENU
      ACTIVATE MENU oMenu AT nRow, nCol OF Self

      oClp:Close()

      if lPaste

         bBlock := ::aoColumns[::nRealCol]:bBlock

         cType := valtype( eval(bBlock) )


         do case
            case cType == "C"
                 uVal  := cClpText
            case cType == "N"
                 uVal := Val( cClpText )
            case cType == "D"
                 cClpText := alltrim( cClpText )
                 uVal := ctod( cClpText )
            case cType == "L"
                 cClpText := alltrim( cClpText )
                 uVal := if( upper(cClpText) == ".T.", .t., .f. )
            otherwise
                 uVal := nil
         endcase

         * tenemos que controlar que el ancho de datos que queremos introducir
         * en el campo no sea mayor que el permitido.


         if uVal == nil
            MsgInfo( MSGDISTINCTYPE )
            return 0
         endif

         if eval( ::aoColumns[::nRealCol]:bValid, cClpText )

            if upper(::cAlias) == "ARRAY"

               ::aTabla [::aoColumns[::nRealCol]:uDato,::nAt ] := cClpText

            else

               if (::cAlias) ->(rlock())

                  BEGIN SEQUENCE

                     eval( bBlock, uVal )          //cClpText )

                  RECOVER USING oValor

                     ErrorBlock ( bErr )
                     * restauro el valor original
                     eval( bBlock, uVar )

                  END SEQUENCE


               else
                  MsgAlert( MSGPASTELOCK )
               endif

               ( ::cAlias )->( DbUnLock() )

            endif
            ::PaintLine()
            ::PaintCell()
         else
            MsgInfo( ::aoColumns[::nRealCol]:cMsgValid )
         endif

      endif
   ENDIF
	 

return 0




*********************************
METHOD _nRealCol() CLASS TGrid
*********************************
local nCol

nCol := ::nColPos + ::nColScr - 1

if empty( nCol )
   nCol := 1
endif


return  nCol

************************************************
METHOD RegisColor( nColor ) CLASS TGrid
************************************************

local nEn
local nReturn
local n
local nLen := Len ( ::aColors )

/*

   Proceso de registro de colores.

      Como tenemos que crear brochas para colorear los fondos,
   lo que hago es que las creo en el proceso de inicio y devuelvo
   el lugar que ocupa en ese array.

      Luego cuando quiera utilizar un color de fondo lo unico que tengo
   que hacer es seleccionar la brocha correspondiente, ej:

    Ŀ
        oHeader := ::aoColumns[ nCol ]:oHeader                          
        SelectObject( ::hDC, ::aBrushes[ oHeader:anClrPane[ 1 ] ] )     
    

           ... para la primera celda de la cabecera de la columna 'nCol'

         este es el caso de colorear las cabeceras. He guardado
         el color que le corresponde a cada celda de cabecera en
         el array anClrPane del objeto oHeader.

*/

for n := 1 to nLen
    if ::aColors[ n ] == nColor
       nEn := n
       exit
    endif
next

if nEn == nil
   aadd( ::aColors, nColor )
   aadd( ::aBrushes, CreateSolidBrush( nColor ) )
   aadd( ::aPens   , CreatePen( PS_SOLID, 1, nColor ) )
   nReturn := len( ::aBrushes )
else
   nReturn := nEn
endif

Return nReturn

********************************************
METHOD RegisFont( oFont )
********************************************
local nEn
local nReturn
local n
local nLen := Len ( ::aFonts )
LOCAL oAux


for n := 1 to nLen

    oAux := ::aFonts[ n ]

    if oAux:cFaceName   == oFont:cFaceName   .and.;
       oAux:nHeight     == oFont:nHeight     .and.;
       oAux:nWidth      == oFont:nWidth      .and.;
       oAux:lBold       == oFont:lBold       .and.;
       oAux:lItalic     == oFont:lItalic     .and.;
       oAux:lUnderline  == oFont:lUnderline  .and.;
       oAux:nEscapement == oFont:nEscapement .and.;
       oAux:lStrikeOut  == oFont:lStrikeOut

       * the font are equals

       nEn := n
       exit

    endif

next

if nEn == nil
   aadd( ::aFonts, oFont )
   nReturn := len( ::aFonts )
else
   nReturn := nEn
endif

Return nReturn

************************************************
METHOD RegisTxtC( nClrText ) CLASS TGrid
************************************************

local nEn
local nReturn
local n
local nLen := Len ( ::aTxtColors )

for n := 1 to nLen
    if ::aTxtColors[ n ] == nClrText
       nEn := n
       exit
    endif
next

if nEn == nil
   aadd( ::aTxtColors, nClrText )
   nReturn := len( ::aTxtColors )
else
   nReturn := nEn
endif

Return nReturn



********************************************
METHOD Seek( cData, lAprox ) CLASS TGrid
********************************************

Local nEn
Local nLines := ::nLines
Local lFind  := .f.
Local nOld := ( ::cAlias ) -> ( Recno() )

DEFAULT lAprox := .f.

( ::cAlias ) -> ( dbseek ( cData, lAprox ) )


   if nOld != ( ::cAlias ) -> ( Recno() )


      if ( ::cAlias ) ->( eof() )
         ( ::cAlias ) -> ( dbgoto( nOld ) )
         Tone( 2000,0.1)
         Tone( 100,1)
         ::cBuffer := ""
      endif


      lFind := .t.










         nEn := int( ( ::cAlias ) -> ( ntxpos( ( ::cAlias ) -> ( IndexOrd() ),( ::cAlias ) -> ( Recno() ) ) ) % ::nLines )









      if nEn == 0
         ::nRowPos := nLines
      else
         ::nRowPos := nEn
      endif

      ::MoveCell()

      if ::nLen > nLines
         ::PaintDatos()
      endif

      ::PaintCell()

      if ::lBar
         ::PaintLine(,,,.t.)
      endif

      if ::bChange != nil
         Eval( ::bChange, Self )
      endif

      ::lHitTop := .f.

   else

      lFind := .f.

   endif


return lFind

*****************************************************
  METHOD SetArray( aArray, lCompatible ) CLASS TGrid
*****************************************************

   DEFAULT lCompatible := .f.

   if ::lCompatible == nil
      ::lCompatible = lCompatible
   endif

   ::aTabla    = aArray

   ::nAt         = 1
   ::cAlias      = "ARRAY"
   ::bLogicLen   = { || Len( if ( ::lCompatible, ::aTabla, ::aTabla[1]) ) }
   ::bGoTop      = { || ::nAt := 1 }
   ::bGoBottom   = { || ::nAt := Eval( ::bLogicLen ) }
   ::bSkip       = { | nSkip, nOld | nOld := ::nAt, ::nAt += nSkip,;
                       ::nAt := Min( Max( ::nAt, 1 ), Eval( ::bLogicLen ) ),;
                       ::nAt - nOld }
   ::nLen        = eval( ::bLogicLen )


return nil

*****************************************
METHOD ChangeArray( aArray ) CLASS TGrid
*****************************************
local n, bBlock

   * utilizar solo cuando el array cambie de tamao pero no de
   * estructura.
   * las columnas tendr n que seguir representando los mismos elementos
   * preferentemente. Podra suceder que pictures, valids, whens, afectaran
   * de forma imprevisible.
   * si no se utiliza as es responsabilidad del usuario.


   ::SetArray( aArray, ::lCompatible )

   for n := 1 to ::nCols

       if !::lCompatible

          if valtype( ::aTabla[n,1] ) == "B"

             bBlock :=   ::aTabla[n,1]

          else

             bBlock := ::DameBlock( ::aTabla[n] )

          endif
       else
          bBlock := ::DameBlock( ::aTabla )
       endif

       ::aoColumns[ n ]:bBlock := bBlock

       sysrefresh()

   next


Return nil

******************************************
METHOD SetDbf( cNomAlias ) CLASS TGrid
******************************************

local nCampos, n, cCampo, bBloque
local oHdr, oCol
LOCAL aBmp := { ".\bmps\DELETED.bmp",;
                ".\bmps\NODELETE.bmp" }

LOCAL cAlign, ctype, nLen, nWidth
local aStruct
local oThis := self
local bBlock
Local nLines := ::nLines
Local nInc
local nAlias

DEFAULT cNomAlias := ::cAlias


nAlias := select( ::cAlias )


nWidth := int( ::oFont:nWidth )

::cAlias := cNomAlias

nCampos := ( ::cAlias ) -> (Fcount())
aStruct := ( ::cAlias ) -> (dbstruct())

DEFINE HEADER oHdr TITLE "Reg." HGRID VGRID COLORPANE CLR_HGRAY BUTTONLOOK

DEFINE COLUMNA oCol OF Self              ;
       WIDTH 50                          ;
       DATA {|| (::cAlias) ->(recno()) } ;
       ALIGN CENTER ;
       NOEDITABLE ;
       HEADER oHdr


DEFINE HEADER oHdr TITLE "del" HGRID VGRID COLORPANE CLR_HGRAY BUTTONLOOK

DEFINE COLUMNA oCol OF Self ;
       WIDTH 25 ;
       BITMAP aBmp ;
       BBITMAP if( ( ::cAlias )->(deleted()) , 1, 2 ) ;
       ALIGNBMP CENTER ;
       HEADER oHdr ;
       ALIGN CENTER ;
       NOEDITABLE


for n := 1 to nCampos

    cCampo := (::cAlias) -> ( FieldName( n ) )

    if ::nLinesHdr > 0

         DEFINE HEADER oHdr TITLE cCampo ;
              HGRID VGRID  ;
              COLORTEXT  CLR_BLACK ;
              COLORPANE  CLR_HGRAY ;
              BUTTONLOOK
    endif

    cType := aStruct[n,2]

    nLen  := nWidth * ( aStruct[n,3] + 6 )


    do case
       case  cType == "N"
             cAlign := "RIGHT"
       case  cType == "C"
             cAlign := "LEFT"
       case  cType == "L"
             cAlign := "CENTER"
       case  cType == "D"
             cAlign := "CENTER"
             nLen  := ( nWidth + 2 ) * ( aStruct[n,3] + 6 )
       case  cType == "M"
             *cAlign := "MULTILINE"
             cAlign := "PLAIN"
             nLen  := int(::GetWidth( replicate("H",80) , ::oFont ))
    endcase

    nLen := Max(nLen, int(::GetWidth( aStruct[n,1] , ::oFont )) + 20 )

    bBlock := fieldwblock( cCampo, nAlias )

    TColGrid():New( bBlock , , nLen, oHdr, Self, , , , , , ,cAlign, , , )

next




return nil



************************************************
  METHOD SetTxt( cTxtFile ) CLASS TGrid
************************************************
   local oFile, oCol
   local aLines := {{}}

   * NO CONFUNDIR ESTE METODO CON SETTEXT
   * settext cambia cCaption y settxt pone un fichero de texto al grid

   * DON'T CONFUSE WITH THE METHOD SETTEXT
   * Settext change cCaption into a control.
   * Settxt  show a text file into a grid


   if ! File( cTxtFile )
      MsgStop( MSGNOTFINDFILE + cTxtFile )
      return nil
   endif

   ::cTxtFile := cTxtFile

   oFile = TTxtFile():New( cTxtFile )

   CursorWait()

   while ! oFile:lEof()
      AAdd( aLines[1], oFile:ReadLine() )
      oFile:Skip()
   end

   oFile:Close()

   ::SetArray( aLines )

   DEFINE COLUMNA oCol OF Self ;
          DATA 1


return nil



// add 27-07-97
**************************************************
METHOD SetValue( nCol, nRow, nElement, nValue )
**************************************************
Local cDef
Local cAux
Local nColumns := len( ::aoColumns )
Local nLines

If ::lIsCreate
   //13-11-97
   if ::lMdiChild
      * grid rezisable
      nLines := 60
   else
      * the grid not resizable
      nLines := ::nLines
   endif
else
   nLines := 60
endif


if nCol <= nColumns .and. nRow <= nLines .and.;
   nCol > 0 .and. nRow > 0

   cDef := ::aoColumns[ nCol ]:aColCells[ nRow ]

   cAux := left( cDef, nElement - 1) + chr( nValue + 64 ) + substr( cDef, nElement + 1 )

   ::aoColumns[ nCol ]:aColCells[ nRow ] := cAux

endif

return nil

// add 27-07-97
**************************************************
METHOD GetValue( nCol, nRow, nElement )
**************************************************

return  asc( substr( ::aoColumns[ nCol ]:aColCells[ nRow ], nElement, 1 ) ) - 64

**************************************************
METHOD Set2Order( nOrder ) CLASS TGrid
**************************************************


(::cAlias) -> (dbsetorder( nOrder ))
::lHitTop := .f.
::GoTop()


Return nil


   ***************************************************************
   * SetFilter From source of Fivewin from A. Linares y F.Pulpon *
   * I have its permit to use it
   ***************************************************************

***************************************************************
METHOD SetFilter( cField, uVal1, uVal2 )
*******************************************

   local cIndexType

   DEFAULT uVal2 := uVal1

   ::cField     = cField
   ::uValue1    = uVal1
   ::uValue2    = uVal2

   // 31-07-98
   ::lFilter    = .t.

   if uVal1 != nil
      cIndexType := ( ::cAlias )->( ValType( &( IndexKey() ) ) )
      if ( ::cAlias )->( ValType( &cField ) ) != cIndexType .or. ;
         ValType( uVal1 ) != cIndexType .or. ;
         ValType( uVal2 ) != cIndexType
         MsgAlert( MSGSETFILTER )
      endif
   endif

   // Posibility of using FILTERs based on INDEXES!!!

   ::bGoTop     = If( uVal1 != nil, { || ( ::cAlias )->( DbSeek( uVal1, .f. ) ) },;
                                    { || ( ::cAlias )->( DbGoTop() ) } )

   ::bGoBottom  = If( uVal2 != nil, { || ( ::cAlias )->( BrwGoBottom( uVal2 ) ) },;
                                    { || ( ::cAlias )->( DbGoBottom() ) } )

   ::bSkip      = If( uVal1 != nil, BuildSkip( ::cAlias, cField, uVal1, uVal2 ),;
                      { | n | ( ::cAlias )->( _DbSkipper( n ) ) } )

   ::bLogicLen  = If( uVal1 != nil,;
                      { || ( ::cAlias )->( Self:RecCount( uVal1 ) ) },;
                      { || ( ::cAlias )->( RecCount() ) } )

   ::nLen       = Eval( ::bLogicLen )

   // 03-08-98
  if ::nLen == 0
      ::nRowPos := 1
      super:Refresh()
   endif

   ::lHitTop    = .f.
   ::lHitBottom = .f.

   if uVal1 != nil
      Eval( ::bGoTop )
   endif

return nil


   ***************************************************************
   * SetFilter From source of Fivewin from A. Linares y F.Pulpon *
   * I have its permit to use it
   ***************************************************************

********************************************
METHOD _RecCount( uSeekValue ) CLASS TGrid
********************************************

   local nRecNo := ( ::cAlias )->( RecNo() )
   local nRecs  := 1
   local bField := &( "{ || " + ::cField + "}" )

   if .not. ( ::cAlias )->( DbSeek( uSeekValue, .f. ) )
      if ( ::cAlias )->( Eval( bField ) ) > ::uValue2 ;
         .or. ( ::cAlias )->( EoF() )
         nRecs := 0
      endif
   endif

   // When Filters show a lot of records, the application
   // may loose a lot of time counting. nMaxFilter controls this
   if ::nMaxFilter == nil
      while ::Skip( 1 ) == 1
         nRecs++
      end
   else
      while ::Skip( 1 ) == 1 .and. nRecs < ::nMaxFilter
         nRecs++
      end
   endif

   ( ::cAlias )->( DbGoTo( nRecNo ) )

return nRecs

// To simulate Filters using INDEXES         -they go extremely fast!-

   ***************************************************************
   * SetFilter From source of Fivewin from A. Linares y F.Pulpon *
   * I have its permit to use it
   ***************************************************************

static function BuildSkip( cAlias, cField, uValue1, uValue2 )

   local bSkipBlock
   local cType := ValType( uValue1 )

   do case
      case cType == "C"
           bSkipBlock = { | n | ( cAlias )->( BrwGoTo( n, ;
           &( "{||" + cField + ">= '" + uValue1 + "' .and." + ;
           cField + "<= '" + uValue2 + "' }" ) ) ) }

      case cType == "D"
           bSkipBlock = { | n | ( cAlias )->( BrwGoTo( n, ;
           &( "{||" + cField + ">= CToD( '" + DToC( uValue1 ) + "') .and." + ;
            cField + "<= CToD( '" + DToC( uValue2 ) + "') }" ) ) ) }

      case cType == "N"
           bSkipBlock = { | n | ( cAlias )->( BrwGoTo( n, ;
           &( "{||" + cField + ">= " + cValToChar( uValue1 ) + " .and." + ;
           cField + "<= " + cValToChar( uValue2 ) + " }" ) ) ) }

      case cType == "L"
           bSkipBlock = { | n | ( cAlias )->( BrwGoTo( n, ;
           &( "{||" + cField + ">= " + cValToChar( uValue1 ) + " .and." + ;
           cField + "<= " + cValToChar( uValue2 ) + " }" ) ) ) }
   endcase

return bSkipBlock

//----------------------------------------------------------------------------//

   ***************************************************************
   * SetFilter From source of Fivewin from A. Linares y F.Pulpon *
   * I have its permit to use it
   ***************************************************************

static function BrwGoTo( n, bWhile )

   local nSkipped := 0, nDirection := If( n > 0, 1, -1 )

   while nSkipped != n .and. Eval( bWhile ) .and. ! EoF() .and. ! BoF()
      DbSkip( nDirection )
      nSkipped += nDirection
   enddo

   do case
      case EoF()
         DbSkip( -1 )
         nSkipped += -nDirection

      case BoF()
         DbGoTo( RecNo() )
         nSkipped++

      case ! Eval( bWhile )
         DbSkip( -nDirection )
         nSkipped += -nDirection
   endcase

return nSkipped

   ***************************************************************
   * SetFilter From source of Fivewin from A. Linares y F.Pulpon *
   * I have its permit to use it
   ***************************************************************

static function BrwGoBottom( uExpr )

   local lSoftSeek := Set( _SET_SOFTSEEK, .t. )

   if ValType( uExpr ) == "C"
      DbSeek( SubStr( uExpr, 1, Len( uExpr ) - 1 ) + ;
              Chr( Asc( SubStr( uExpr, Len( uExpr ) ) ) + 1 ) )
   else
      DbSeek( uExpr + 1 )
   endif
   DbSkip( -1 )

   Set( _SET_SOFTSEEK, lSoftSeek )

return nil


**************************************************
METHOD SetHRow ( nHRow )  CLASS TGrid
**************************************************
local nLines, nLast, n

DEFAULT nHrow := ::nHRow

* d'ont use in runtime. Only for design time ( preferably )
* if you use this method in run time, you will have to go to the first record
* in the grid.

* no usar en tiempo de ejecucin. Solo para diseo ( preferiblemente )
* si usa este metodo en tiempo de ejecucin deber  ir al primer registro del
* grid


::CoorsUpdate()

::nHRow  := nHRow

::GoTop()


Return nil

**********************************************
METHOD InsertCol( nCol, nCol2 ) CLASS TGrid
**********************************************

local n, lRefresh := .f.


if nCol == nCol2
   Return nil
endif

if nCol2 > nCol

   for n := nCol2 to nCol  STEP -1

       if n == nCol + 1
          lRefresh := .t.
       endif

       ::SwitchCol( n, n - 1, lRefresh )

       if n == nCol + 1
          exit
       endif

   next

else

   for n := nCol2 to nCol  STEP 1

       if n == nCol - 1
          lRefresh := .t.
       endif

       ::SwitchCol( n, n + 1, lRefresh )

       if n == nCol - 1
          exit
       endif

   next

endif

return nil

*******************************************
METHOD SwitchCol( nCol, nCol2, lRefresh ) CLASS TGrid
*******************************************
local oAuxCol, aAuxaCell

DEFAULT lRefresh := .t.

if empty( nCol2 )
   nCol2 := 1
endif

oAuxCol := ::aoColumns[ nCol ]

::aoColumns[ nCol  ] := ::aoColumns[ nCol2 ]
::aoColumns[ nCol2 ] := oAuxCol

if lRefresh
   ::MoveCell()
   ::Paint()
endif

Return nil


***************************************
METHOD Skip( n ) CLASS TGrid
***************************************
Local nSkip

   if ::bSkip != nil
      Return Eval( ::bSkip, n )
   endif

return _DBSkipper( n )



****************************************
  METHOD TotalCols() CLASS TGrid
****************************************
Local n, n1
Local nLen

if upper(::cAlias) == "ARRAY"
   nLen := eval( ::bLogicLen )
   For n := 1 to nLen
       For n1 := 1 to ::nCols
           if ::aoColumns[n1]:oFoot != nil
              if ::aoColumns[n1]:oFoot:bDato != nil
                 if ::aoColumns[n1]:oFoot:cTitle == nil

                    if n == 1
                       ::aoColumns[n1]:oFoot:nAcum := 0
                    endif

                    ::aoColumns[n1]:oFoot:nAcum += eval(::aoColumns[n1]:oFoot:bDato, n )

                 endif
              endif
           endif
       next n1
   next n

else

   * ejecutar este mtodo penaliza en tiempo por cada ::Paint que hagamos
   * porque se tiene que recorrer la base de datos entera totalizando
   * todos los pies. Es el programador el que evaluar  la conveniencia del uso
   * en bases de datos compartidas.

   * to execute this method penalizes in time by each ::Paint that we make
   * because has to travel the database deposits totalling all the feet.  It is
   * theprogrammer will evaluate the convenience of the use on the
   * shared databases.


   nLen := eval( ::bLogicLen )

////////////////////////////////////////

   *(::cAlias) -> ( dbgotop() ) // modify 27/08/97
   eval( ::bGotop )             // the totalization must be of the
                                // real scope of database.


   For n := 1 to nLen

       For n1 := 1 to ::nCols

           *  if have a foot...
           if ::aoColumns[n1]:oFoot != nil

              * if have to totalize...
              if ::aoColumns[n1]:oFoot:bDato != nil

                 if ::aoColumns[n1]:oFoot:cTitle == nil

                    if n == 1
                       ::aoColumns[n1]:oFoot:nAcum := 0
                    endif

                    ::aoColumns[n1]:oFoot:nAcum += eval(::aoColumns[n1]:oFoot:bDato )

                 endif
              endif
           endif

       next n1

       * (::cAlias) ->(dbskip())    // modify 27/08/97
                                    // the totalization must be of the
                                    // real scope of database.
       eval( ::bSkip, 1 )

   next n

   * (::cAlias) -> (dbgotop())      // modify 27/08/97
   eval( ::bGoTop )                 // the totalization must be of the
                                    // real scope of database.


endif

CursorArrow()

return nil


****************************************
METHOD VertLine( nColPos, nColInit ) CLASS TGrid
****************************************

   local oRect, lRefresh := .f.
   local nAuxWidth := 0

   static nCol, nWidth, nOldPos := 0

   if nColInit != nil
      nCol    = nColInit
      nWidth  = nColPos
      nOldPos = 0
   endif

   if nColPos == nil .and. nColInit == nil   // We have finish draging

      nAuxWidth := ::aoColumns[ nCol ]:nWidth
      ::aoColumns[ nCol ]:nWidth -= ( nWidth - nOldPos )
      lRefresh := .t.

   endif

   oRect = ::GetRect()
   ::GetDC()

   if nOldPos != 0
      InvertRect( ::hDC, { 0, nOldPos -1, oRect:nBottom, nOldPos + 1 } )
      nOldPos = 0
   endif
   if nColPos != nil .and. ( nColPos - 2 ) > 0
      InvertRect( ::hDC, { 0, nColPos -1, oRect:nBottom, nColPos + 1 } )
      nOldPos = nColPos
   endif

   ::ReleaseDC()
   ::hDC := nil

   If lRefresh
      if nAuxWidth <> ::aoColumns[ nCol ]:nWidth
         ::MoveCell()
         ::Paint()
      endif
   endif


return nil

return nil

***********************************************
METHOD VScroll( nWParam, nLParam ) CLASS TGrid
***********************************************
Local nOrder := 0         //add 10-12-1997
Local nEn    := ::nRowPos //add 22-12-1997

   if GetFocus() != ::hWnd
      SetFocus( ::hWnd )
   endif

   do case
      case nWParam == SB_LINEUP

           if ::lNoHilite
              ::PageUp()
           else
              ::GoUp()
           endif

      case nWParam == SB_LINEDOWN

           if ::lNoHilite()
              ::PageDown()
           else
              ::GoDown()
           endif

      case nWParam == SB_PAGEUP
           ::PageUp()

      case nWParam == SB_PAGEDOWN
           ::PageDown()

      case nWParam == SB_THUMBPOSITION

           do case
              case nLParam == 1
                   Return ::GoTop()
              case nLParam == ::oVScroll:GetRange()[ 2 ]
                   Return ::GoBottom()
           endcase

           if ::cAlias != "ARRAY"    // add 10-12-1997
              nOrder := ( ::cAlias ) -> ( IndexOrd() )
           ENDIF

           *04-01-1998
           *if ( ::nLen := Eval( ::bLogicLen ) ) < 1
           if ::nLen < 1
              return 0
           endif

           CursorWait()

           ::Skip( nLParam - ::oVScroll:GetPos() )
           ::lHitTop = .f.
           ::lHitBottom = .f.

           CursorArrow()

           ::oVScroll:SetPos( nLParam )

           if nLParam - ::oVScroll:nMin < ::nLines
              ::nRowPos = 1
           endif

           if ::oVScroll:nMax - nLParam < Min( ::nLines, ::nLen )
              nEn := Min( ::nLines, ::nLen ) - ( ::oVScroll:nMax - nLParam )
           endif


           if ::cAlias != "ARRAY"  // add 10-12-1997
              if empty( ( ::cAlias ) ->( dbfilter() ) )
                 if nOrder != 0
                    // (nEn) modify 22-12-1997
                    nEn := int( ( ::cAlias ) -> ( ntxpos( ( ::cAlias ) -> ( IndexOrd() ),( ::cAlias ) -> ( Recno() ) ) ) % ::nLines )
                 endif
              endif
           endif

           // modify at 22-12-1997

           if nEn == 0
              ::nRowPos := ::nLines
           else
              ::nRowPos := nEn
           endif

           *::Refresh( .f. )
           ::Refresh()

           if ::bChange != nil
              Eval( ::bChange, Self )
           endif

      otherwise

           return nil
   endcase

return 0


METHOD ver( c, u ) CLASS TGrid

::oWnd:cTitle := c + "  " + cvaltochar( u )

return nil

************************
  METHOD _nLines() CLASS TGrid
************************

local nLines := ::nRowCount() - if (::lFoots,1,0)

return  nLines

****************************************************
      METHOD InitTimeOut( oDlg ) CLASS TGrid
****************************************************


DEFINE TIMER ::oTimeOut INTERVAL (::nTimeOut * 1000) ;
       ACTION ( oDlg:End(), ::EndTimeOut(), ::oTimeOut := nil, MsgInfo("Superado TimeOut") )

ACTIVATE TIMER ::oTimeOut

Return nil

****************************************************
      METHOD EndTimeOut() CLASS TGrid
****************************************************

::oTimeOut:End()

   if upper(::cAlias) != "ARRAY"
      ( ::cAlias )->( DbUnLock() )
   endif

Return nil


**********************************************
METHOD GetDlgCode( nLastKey ) CLASS TGrid
**********************************************

   // This method is very similar to TControl:GetDlgCode() but it is
   // necessary to have WHEN working

   if .not. ::oWnd:lValidating
      if nLastKey == VK_UP .or. nLastKey == VK_DOWN ;
         .or. nLastKey == VK_RETURN .or. nLastKey == VK_TAB
         ::oWnd:nLastKey = nLastKey
      else
         ::oWnd:nLastKey = 0
      endif
   endif

return DLGC_WANTALLKEYS


************************************************
METHOD cToChar( cCtrlClass ) CLASS TGrid
************************************************

   local n := GetDlgBaseUnits()

   if ::lNoAutoSize
      Return Super:cToChar( cCtrlClass )
   endif

   DEFAULT cCtrlClass := ::ClassName(),;
           ::cCaption := "",;
           ::nId      := ::GetNewId(),;
           ::nStyle   := nOR( WS_CHILD, WS_VISIBLE, WS_TABSTOP )

return cCtrl2Chr( Int(  8 * ::nTop    / nHiWord( n ) ),;
                  Int(  4 * ::nLeft   / nLoWord( n ) ),;
                  Int(  8 * ::nBottom / nHiWord( n ) ),;
                  Int(  4 * ::nRight  / nLoWord( n ) ),;
                  ::nId, ::nStyle, cCtrlClass, ::cCaption )


*******************************************
METHOD MiError( oError )
*******************************************

if oError:GenCode == 34
   MsgAlert( MSGERRORWIDTH )
   Break( oError )
endif

return .f.


********************************************
METHOD xDelete()
* 25-02-1998 V 2.0N
********************************************
Local nOrder
Local cKey
Local cData
Local nAux
Local lEof := .f.

* ESTE METODO SOLO SE UTILIZA CUANDO EL GRID MUESTRA UNA BASE DE DATOS
* NO SE PUEDE UTILIZAR SI SE ESTA MOSTRANDO UN ARRAY

dbselectar( ::cAlias )

nOrder := (::cAlias) -> ( indexOrd() )

if nOrder != 0

    * Estamos borrando con un indice activo
    * Hay que resituar el puntero si SET DELETED est a on

    cKey  := (::cAlias ) ->(indexkey( nOrder ))
    cData := ( &cKey )

    if (::cAlias) ->(dbrlock())
       (::cAlias) ->(dbdelete())
       (::cAlias) ->(dbunlock())
    else
       MsgAlert( TITLE_LOCKED )
       return nil
    endif

    (::cAlias) ->( dbseek( cData, .t. ))

    if (::cAlias) ->(eof())
       lEof := .t.
       (::cAlias)->(dbGobottom())
    endif

    nAux := int( ntxpos(  (::cAlias)->(IndexOrd()) , (::cAlias)->(Recno()) )   % ::nLines )

    if nAux == 0
       ::nRowPos := min( ::nRowPos := ::nLines, ::xReccount() )
    else
       ::nRowPos := nAux
    endif

else

    if (::cAlias) ->(dbrlock())
       (::cAlias) ->(dbdelete())
       (::cAlias) ->(dbunlock())
    else
       MsgAlert( TITLE_LOCKED )
       return nil
    endif

    (::cAlias) ->(dbskip(1))
    (::cAlias) ->(dbskip(-1))

endif



return nil

**************************************
  METHOD nCalcRow( nOrder, nOldRec )
**************************************
Local lRefresh := .f.
Local nAux
Local nOldRow := ::nRowPos
Local nLogRec

DEFAULT nOrder  := (::cAlias)->(IndexOrd())

  //31-07-98
  if ::lFilter
     return .t.
  endif


  if ::cAlias != "ARRAY" .and. nOrder != 0

     nLogRec :=  ntxpos(  nOrder , (::cAlias)->( Recno()) )
     nAux := int( nLogRec  % ::nLines )


     if nAux != nOldRow .or. nOldRec != nLogRec
        lRefresh := .t.
     endif

     if nAux == 0
        ::nRowPos := ::nLines
     else
        ::nRowPos := nAux
     endif

  endif



Return lRefresh

*******************************************
METHOD xReccount()
*******************************************
Local nReg    := ( ::cAlias ) ->( recno() )
Local nOrder  := (::cAlias)->(IndexOrd())

  if nOrder != 0

     ( ::cAlias ) ->( dbgobottom() )

     ::nLen  := ntxpos(  nOrder , (::cAlias)->( Recno()) )

     ( ::cAlias ) ->( dbgoto( nReg ) )

     if ::oVScroll != nil
        ::oVScroll:SetRange( 1, ::nLen )
     endif

  else
     ::nLen := ( ::cAlias ) ->( reccount() )
     if ::oVScroll != nil
        ::oVScroll:SetRange( 1, ::nLen )
     endif
  endif

return ::nLen

********************************
METHOD GotFocus()
********************************
Local nRec

Super:GotFocus()

If ::cAlias != "ARRAY"

   dbselectar( ::cAlias )

   if ::lEditting
      ::lEditting := .f.
   else
      if ::nCalcRow()
         ::Paint()
      endif
   endif

endif

return nil

***************************
METHOD Refresh( lErase )
***************************

Local nRec

DEFAULT lErase := .t.


If ::cAlias != "ARRAY"

   dbselectar( ::cAlias )

   if ::lEditting
      ::lEditting := .f.
   else
      if ::nCalcRow() .or. lErase
         ::Paint()
      endif
   endif

else
  super:Refresh( lErase )
endif

return nil

****************************************************************
METHOD BtnLook( hDC, nTop, nLeft, nBottom, nRight )
****************************************************************
Local hOldPen


   hOldPen := SelectObject( hDC, ::hBordeIz )

   Moveto( hDC, nLeft, nBottom - 2 ) //- 2)
   Lineto( hDC, nLeft, nTop        ) // )
   Lineto( hDC, nRight -1, nTop    ) //)

   SelectObject( hDC, hOldPen )
   hOldPen := SelectObject( hDC, ::hBordeDer )

   Moveto( hDC, nRight -2 , nTop    + 1 ) //+ 1)
   Lineto( hDC, nRight -2 , nBottom - 2 ) //- 2 )
   Lineto( hDC, nLeft -1, nBottom   - 2 ) // -2 )

   SelectObject( hDC, hOldPen )


return nil

********************************
METHOD AdjCols( nIni, nWidth )
********************************

Local n
Local nCols := ::nCols

DEFAULT nIni := 1


for n := nIni TO ::nCols

      if ::aoColumns[ n ]:nWidth > nWidth
       ::aoColumns[ n ]:nWidth := nWidth
    endif

next

return nil

******************************************
   METHOD ADelRow( nRow )
******************************************

local n
local lNeedGoBo := .f.

DEFAULT nRow := ::nAt

if ( ::cAlias ) != "ARRAY"
   return nil
endif

if nRow == ::nLen
   lNeedGoBo := .t.
endif


for n := 1 to len( ::aTabla )
    adel ( ::aTabla[n], nRow )
    asize( ::aTabla[n], len( ::aTabla[n] ) - 1 )
next n

if lNeedGoBo
   ::GoUp()
   ::Refresh()
else
   ::Refresh()
endif

return nil

***********************************************
METHOD NewArray( aTabla )
***********************************************

if ::cAlias != "ARRAY"
   asize( ::aTabla , 0 )
   ::aArray := aTabla
   ::GoTop()
   ::Refresh()
endif

return nil

***************************************
   METHOD ASeek( uValue, nCol )
***************************************

Local nEn
Local nLines := ::nLines
Local lFind  := .f.
Local nOld := ::nAt


if ::cAlias == "ARRAY"

   nEn := ascan( ::aTabla[ nCol ], {|x,nx| x == uValue } )

   if nEn != 0

      ::nAt := nEn

      nEn := int( nEn % ::nLines )

      if nEn == 0
         ::nRowPos := nLines
      else
         ::nRowPos := nEn
      endif


      ::MoveCell()

      if ::nLen > nLines
         ::PaintDatos()
      endif

      ::PaintCell()

      if ::lBar
         ::PaintLine(,,,.t.)
      endif

      if ::bChange != nil
         Eval( ::bChange, Self )
      endif

      ::lHitTop := .f.

   else

      lFind := .f.

   endif

endif

return lFind









