/*
 Programa Ŀ
   Aplication: class TColGrid                                             
         File: COLUMNA.PRG                                                
       Author: Francisco Garca Fern ndez                                 
     Internet: http://www.arrakis.es/~canal_five/                         
     Internet: http://come.to/canalfive                                   
       E-Mail: canalfive@solution4u.com                                   
         Date: 25-feb-1998                                                
         Time: 09:00:00                                                   
      Version: 2.0S                                                       
    Copyright: 1997 by Francisco Garca Fernndez                         

*/
#include "fivewin.ch"

#define ALINEACION {32,33,34,36,37,38,40,41,42,0,16,17 }
#define CALIGN {"TOP_LEFT","TOP_CENTER","TOP_RIGHT",;
                "LEFT","CENTER","RIGHT",;
                "BOTTOM_LEFT","BOTTOM_CENTER","BOTTOM_RIGHT",;
                "PLAIN", "MULTILINE", "MULTICENTER" }


CLASS TColGrid

      DATA oGrid

      DATA oHeader

      DATA bBlock
      DATA uDato
      DATA bValid, bWhen, cMsgWhen, cMsgValid

      DATA aBitmaps, aHBitmaps, aSizesBmps
      DATA bBitmap, nAjusteBmp
      DATA lEditable
      DATA lNoPaintData
      DATA lOem
      DATA aSelDato

      DATA nWidth
      DATA oFoot

      DATA oFont

      DATA aBCalcCoor

      DATA nClrPane, nClrText, bColor, nBClrPane, nBClrText

      DATA nAjuste
      DATA cPicture
      DATA bAction
      DATA lAutoViewBmp

      // 27-07-97
      DATA aColCells

      // 2.0S
      DATA cEdPicture

      METHOD New( uDato, aBitmaps, nWidth, oHeader, oGrid,;
                  oFont, nClrPane, nClrText, bColor, ;
                  nBClrPane, nBClrText, cAjuste, bBitmap,;
                  oFoot, cAjusteBmp, lEditable, bWhen, bValid,;
                  cMsgWhen, cMsgValid, cPicture, bAction,;
                  lNoPaintData, aSelDato, lOem,;
                  lAutoViewBmp, cEdPicture ) CONSTRUCTOR


ENDCLASS

**********************************************************************
METHOD New( uDato, aBitmaps, nWidth, oHeader, oGrid,;
            oFont, nClrPane, nClrText, bColor,;
            nBClrPane, nBClrText, cAjuste, bBitmap,;
            oFoot, cAjusteBmp, lEditable, bWhen, bValid,;
            cMsgWhen, cMsgValid, cPicture, bAction,;
            lNoPaintData, aSelDato, lOem, lAutoViewBmp, cEdPicture )
**********************************************************************

           Local nClrInAB, nClrActB




         DEFAULT oFont := oGrid:oFont, cAjuste := "LEFT",;
                          cAjusteBmp := "CENTER", lEditable := .t.,;
                          nWidth := 100, bWhen := {||.t.}, bValid := {||.t.},;
                          cMsgWhen := "Valor no valido",;
                          cMsgValid := "Valor no valido",;
                          lNoPaintData := .F., lOem := .f.,;
                          nClrPane := oGrid:nClrPane,;
                          nClrText := oGrid:nClrText,;
                          lAutoViewBmp := .f.



         ::uDato      := uDato
         ::aBitmaps   := aBitmaps
         ::aHBitmaps  := if ( ::aBitmaps != nil,array( Len( ::aBitmaps ) ),nil)
         ::aSizesBmps := if ( ::aBitmaps != nil,array( Len( ::aBitmaps ) ),nil)
         ::nWidth     := nWidth

         ::oHeader    := oHeader
         ::oGrid      := oGrid
         ::oFont      := oFont

         ::nClrPane   := nClrPane
         ::nClrText   := nClrText
         ::bColor     := bColor
         ::nBClrPane  := nBClrPane
         ::nBClrText  := nBClrText
         ::nAjuste    := ALINEACION[ ascan( CALIGN, cAjuste ) ]
         ::nAjusteBmp := ascan( CALIGN, cAjusteBmp )
         ::lEditable    := lEditable
         ::lNoPaintData := lNoPaintData
         ::lOem         := lOem
         ::lAutoViewBmp := lAutoViewBmp

         ::bWhen      := bWhen
         ::bValid     := bValid
         ::cMsgWhen   := cMsgWhen
         ::cMsgValid  := cMsgValid
         ::bAction    := bAction

         ::bBitmap    := bBitmap
         ::oFoot      := oFoot

         ::cPicture   := cPicture
         ::aSelDato   := aSelDato

         ::cEdPicture := cEdPicture

         * array de codeblocks para calcular el nTop y nLeft del bmp
         * que sierven para ajustar a *  *  *
         *
         *                            *  *  *
         *
         *                            *  *  *
         * se pasa como parametros la coordenada, el objeto columna,
         * el numero de bitmap y el alto de fila

         ::aBCalcCoor := { ;
             { {|nTopCell|  nTopCell  + 3 },;
               {|nLeftCell| nLeftCell + 3 }   } ,;
             { {|nTopCell |  nTopCell  + 3 },;
               {|nLeftCell, oC, nBmp | nLeftCell + int(oC:nWidth/2) - oC:aSizesBmps[nBmp,3] } } ,;
             { {|nTopCell |  nTopCell  + 3 },;
               {|nLeftCell, oC, nBmp | nLeftCell + oC:nWidth  - oC:aSizesBmps[nBmp,1] - 3} } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + int( nHRow / 2 ) - oC:aSizesBmps[nBmp,4] },;
               {|nLeftCell| nLeftCell + 3 } } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + int( nHRow / 2 ) - oC:aSizesBmps[nBmp,4] },;
               {|nLeftCell, oC, nBmp | nLeftCell + int(oC:nWidth/2)  - oC:aSizesBmps[nBmp,3] } } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + int( nHRow / 2 ) - oC:aSizesBmps[nBmp,4] },;
               {|nLeftCell, oC, nBmp | nLeftCell + oC:nWidth  - oC:aSizesBmps[nBmp,1] - 3} } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + nHRow - oC:aSizesBmps[nBmp,2] },;
               {|nLeftCell| nLeftCell + 3 } } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + nHRow - oC:aSizesBmps[nBmp,2] },;
               {|nLeftCell, oC, nBmp | nLeftCell + int(oC:nWidth/2)  - oC:aSizesBmps[nBmp,3] } } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + nHRow - oC:aSizesBmps[nBmp,2] },;
               {|nLeftCell, oC, nBmp | nLeftCell + oC:nWidth  - oC:aSizesBmps[nBmp,1] - 3} } }

            oGrid:AddColumn( self )




Return self






